package common

/*
 * This file is part of Autogits.
 *
 * Copyright © 2024 SUSE LLC
 *
 * Autogits is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version.
 *
 * Autogits is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * Foobar. If not, see <https://www.gnu.org/licenses/>.
 */

const examplePushJSON = `{
  "ref": "refs/heads/main",
  "before": "9fe6b18fee74f49786c39e062ef02bcfb560a0be6eb7851b81954123e2d55629",
  "after": "7d0be2432c179873081b715b8d38a563b8469608e110205821ba6a894e63c616",
  "compare_url": "https://src.opensuse.org/autogits/_ObsPrj/compare/9fe6b18fee74f49786c39e062ef02bcfb560a0be6eb7851b81954123e2d55629...7d0be2432c179873081b715b8d38a563b8469608e110205821ba6a894e63c616",
  "commits": [
    {
      "id": "7d0be2432c179873081b715b8d38a563b8469608e110205821ba6a894e63c616",
      "message": "Automatic project inclusion\n",
      "url": "https://src.opensuse.org/autogits/_ObsPrj/commit/7d0be2432c179873081b715b8d38a563b8469608e110205821ba6a894e63c616",
      "author": {
        "name": "GiteaBot - AutoDevel",
        "email": "not-exist@src.opensuse.org",
        "username": ""
      },
      "committer": {
        "name": "root",
        "email": "not-exist@src.opensuse.org",
        "username": ""
      },
      "verification": null,
      "timestamp": "2024-06-25T14:38:31Z",
      "added": [
        ".gitmodules",
        "nodejs22"
      ],
      "removed": [],
      "modified": []
    }
  ],
  "total_commits": 1,
  "head_commit": {
    "id": "7d0be2432c179873081b715b8d38a563b8469608e110205821ba6a894e63c616",
    "message": "Automatic project inclusion\n",
    "url": "https://src.opensuse.org/autogits/_ObsPrj/commit/7d0be2432c179873081b715b8d38a563b8469608e110205821ba6a894e63c616",
    "author": {
      "name": "GiteaBot - AutoDevel",
      "email": "not-exist@src.opensuse.org",
      "username": ""
    },
    "committer": {
      "name": "root",
      "email": "not-exist@src.opensuse.org",
      "username": ""
    },
    "verification": null,
    "timestamp": "2024-06-25T14:38:31Z",
    "added": [
      ".gitmodules",
      "nodejs22"
    ],
    "removed": [],
    "modified": []
  },
  "repository": {
    "id": 90487,
    "owner": {
      "id": 983,
      "login": "autogits",
      "login_name": "",
      "source_id": 0,
      "full_name": "",
      "email": "",
      "avatar_url": "https://src.opensuse.org/avatars/80a61ef3a14c3c22f0b8b1885d1a75d4",
      "html_url": "https://src.opensuse.org/autogits",
      "language": "",
      "is_admin": false,
      "last_login": "0001-01-01T00:00:00Z",
      "created": "2024-06-20T09:46:37+02:00",
      "restricted": false,
      "active": false,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "autogits"
    },
    "name": "_ObsPrj",
    "full_name": "autogits/_ObsPrj",
    "description": "",
    "empty": false,
    "private": false,
    "fork": false,
    "template": false,
    "parent": null,
    "mirror": false,
    "size": 27,
    "language": "",
    "languages_url": "https://src.opensuse.org/api/v1/repos/autogits/_ObsPrj/languages",
    "html_url": "https://src.opensuse.org/autogits/_ObsPrj",
    "url": "https://src.opensuse.org/api/v1/repos/autogits/_ObsPrj",
    "link": "",
    "ssh_url": "gitea@src.opensuse.org:autogits/_ObsPrj.git",
    "clone_url": "https://src.opensuse.org/autogits/_ObsPrj.git",
    "original_url": "",
    "website": "",
    "stars_count": 0,
    "forks_count": 0,
    "watchers_count": 1,
    "open_issues_count": 0,
    "open_pr_counter": 0,
    "release_counter": 0,
    "default_branch": "main",
    "archived": false,
    "created_at": "2024-06-25T13:52:03+02:00",
    "updated_at": "2024-06-25T16:20:44+02:00",
    "archived_at": "1970-01-01T01:00:00+01:00",
    "permissions": {
      "admin": true,
      "push": true,
      "pull": true
    },
    "has_issues": true,
    "internal_tracker": {
      "enable_time_tracker": false,
      "allow_only_contributors_to_track_time": true,
      "enable_issue_dependencies": true
    },
    "has_wiki": true,
    "has_pull_requests": true,
    "has_projects": true,
    "projects_mode": "all",
    "has_releases": true,
    "has_packages": true,
    "has_actions": true,
    "ignore_whitespace_conflicts": false,
    "allow_merge_commits": true,
    "allow_rebase": true,
    "allow_rebase_explicit": true,
    "allow_squash_merge": true,
    "allow_fast_forward_only_merge": true,
    "allow_rebase_update": true,
    "default_delete_branch_after_merge": false,
    "default_merge_style": "merge",
    "default_allow_maintainer_edit": false,
    "avatar_url": "https://src.opensuse.org/",
    "internal": false,
    "mirror_interval": "",
    "object_format_name": "sha256",
    "mirror_updated": "0001-01-01T00:00:00Z",
    "repo_transfer": null
  },
  "pusher": {
    "id": 129,
    "login": "adamm",
    "login_name": "",
    "source_id": 0,
    "full_name": "Adam Majer",
    "email": "adamm@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
    "html_url": "https://src.opensuse.org/adamm",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-07-21T16:43:48+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "adamm"
  },
  "sender": {
    "id": 129,
    "login": "adamm",
    "login_name": "",
    "source_id": 0,
    "full_name": "Adam Majer",
    "email": "adamm@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
    "html_url": "https://src.opensuse.org/adamm",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-07-21T16:43:48+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "adamm"
  }
}
`

const repoCreateJSON = `{
 "action": "created",
 "repository": {
  "id": 87483,
  "owner": {
   "id": 983,
   "login": "autogits",
   "login_name": "",
   "source_id": 0,
   "full_name": "",
   "email": "",
   "avatar_url": "https://src.opensuse.org/avatars/80a61ef3a14c3c22f0b8b1885d1a75d4",
   "html_url": "https://src.opensuse.org/autogits",
   "language": "",
   "is_admin": false,
   "last_login": "0001-01-01T00:00:00Z",
   "created": "2024-06-20T09:46:37+02:00",
   "restricted": false,
   "active": false,
   "prohibit_login": false,
   "location": "",
   "website": "",
   "description": "",
   "visibility": "public",
   "followers_count": 0,
   "following_count": 0,
   "starred_repos_count": 0,
   "username": "autogits"
  },
  "name": "nodejs22",
  "full_name": "autogits/nodejs22",
  "description": "",
  "empty": false,
  "private": false,
  "fork": true,
  "template": false,
  "parent": {
   "id": 54598,
   "owner": {
    "id": 64,
    "login": "pool",
    "login_name": "",
    "source_id": 0,
    "full_name": "",
    "email": "",
    "avatar_url": "https://src.opensuse.org/avatars/b10a8c0bede9eb4ea771b04db3149f28",
    "html_url": "https://src.opensuse.org/pool",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-03-01T14:41:17+01:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "pool"
   },
   "name": "nodejs22",
   "full_name": "pool/nodejs22",
   "description": "",
   "empty": false,
   "private": false,
   "fork": false,
   "template": false,
   "parent": null,
   "mirror": false,
   "size": 190,
   "language": "",
   "languages_url": "https://src.opensuse.org/api/v1/repos/pool/nodejs22/languages",
   "html_url": "https://src.opensuse.org/pool/nodejs22",
   "url": "https://src.opensuse.org/api/v1/repos/pool/nodejs22",
   "link": "",
   "ssh_url": "gitea@src.opensuse.org:pool/nodejs22.git",
   "clone_url": "https://src.opensuse.org/pool/nodejs22.git",
   "original_url": "",
   "website": "",
   "stars_count": 0,
   "forks_count": 3,
   "watchers_count": 4,
   "open_issues_count": 0,
   "open_pr_counter": 1,
   "release_counter": 0,
   "default_branch": "factory",
   "archived": false,
   "created_at": "2024-05-28T12:47:21+02:00",
   "updated_at": "2024-06-12T14:54:03+02:00",
   "archived_at": "1970-01-01T01:00:00+01:00",
   "permissions": {
    "admin": true,
    "push": true,
    "pull": true
   },
   "has_issues": true,
   "internal_tracker": {
    "enable_time_tracker": false,
    "allow_only_contributors_to_track_time": true,
    "enable_issue_dependencies": true
   },
   "has_wiki": true,
   "has_pull_requests": true,
   "has_projects": true,
   "projects_mode": "",
   "has_releases": true,
   "has_packages": true,
   "has_actions": false,
   "ignore_whitespace_conflicts": false,
   "allow_merge_commits": true,
   "allow_rebase": true,
   "allow_rebase_explicit": true,
   "allow_squash_merge": true,
   "allow_fast_forward_only_merge": false,
   "allow_rebase_update": true,
   "default_delete_branch_after_merge": false,
   "default_merge_style": "merge",
   "default_allow_maintainer_edit": false,
   "avatar_url": "https://src.opensuse.org/",
   "internal": false,
   "mirror_interval": "",
   "object_format_name": "sha256",
   "mirror_updated": "0001-01-01T00:00:00Z",
   "repo_transfer": null
  },
  "mirror": false,
  "size": 0,
  "language": "",
  "languages_url": "https://src.opensuse.org/api/v1/repos/autogits/nodejs22/languages",
  "html_url": "https://src.opensuse.org/autogits/nodejs22",
  "url": "https://src.opensuse.org/api/v1/repos/autogits/nodejs22",
  "link": "",
  "ssh_url": "gitea@src.opensuse.org:autogits/nodejs22.git",
  "clone_url": "https://src.opensuse.org/autogits/nodejs22.git",
  "original_url": "",
  "website": "",
  "stars_count": 0,
  "forks_count": 0,
  "watchers_count": 0,
  "open_issues_count": 0,
  "open_pr_counter": 0,
  "release_counter": 0,
  "default_branch": "factory",
  "archived": false,
  "created_at": "2024-06-20T10:09:12+02:00",
  "updated_at": "2024-06-20T10:09:12+02:00",
  "archived_at": "1970-01-01T01:00:00+01:00",
  "permissions": {
   "admin": true,
   "push": true,
   "pull": true
  },
  "has_issues": false,
  "has_wiki": false,
  "has_pull_requests": true,
  "has_projects": false,
  "projects_mode": "all",
  "has_releases": false,
  "has_packages": false,
  "has_actions": false,
  "ignore_whitespace_conflicts": false,
  "allow_merge_commits": true,
  "allow_rebase": true,
  "allow_rebase_explicit": true,
  "allow_squash_merge": true,
  "allow_fast_forward_only_merge": true,
  "allow_rebase_update": true,
  "default_delete_branch_after_merge": false,
  "default_merge_style": "merge",
  "default_allow_maintainer_edit": false,
  "avatar_url": "https://src.opensuse.org/",
  "internal": false,
  "mirror_interval": "",
  "object_format_name": "sha256",
  "mirror_updated": "0001-01-01T00:00:00Z",
  "repo_transfer": null
 },
 "organization": {
  "id": 983,
  "login": "autogits",
  "login_name": "",
  "source_id": 0,
  "full_name": "",
  "email": "autogits@noreply@src.opensuse.org",
  "avatar_url": "https://src.opensuse.org/avatars/80a61ef3a14c3c22f0b8b1885d1a75d4",
  "html_url": "https://src.opensuse.org/autogits",
  "language": "",
  "is_admin": false,
  "last_login": "0001-01-01T00:00:00Z",
  "created": "2024-06-20T09:46:37+02:00",
  "restricted": false,
  "active": false,
  "prohibit_login": false,
  "location": "",
  "website": "",
  "description": "",
  "visibility": "public",
  "followers_count": 0,
  "following_count": 0,
  "starred_repos_count": 0,
  "username": "autogits"
 },
 "sender": {
  "id": 129,
  "login": "adamm",
  "login_name": "",
  "source_id": 0,
  "full_name": "Adam Majer",
  "email": "adamm@noreply@src.opensuse.org",
  "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
  "html_url": "https://src.opensuse.org/adamm",
  "language": "",
  "is_admin": false,
  "last_login": "0001-01-01T00:00:00Z",
  "created": "2023-07-21T16:43:48+02:00",
  "restricted": false,
  "active": false,
  "prohibit_login": false,
  "location": "",
  "website": "",
  "description": "",
  "visibility": "public",
  "followers_count": 0,
  "following_count": 0,
  "starred_repos_count": 0,
  "username": "adamm"
 }
}`

const createBranchJSON = `{
  "sha": "691c91e5240f24f5a75393caf8a78826b8a6f9f272ab4faef024102739f0060a",
  "ref": "main",
  "ref_type": "branch",
  "repository": {
    "id": 90992,
    "owner": {
      "id": 939,
      "login": "importtest",
      "login_name": "",
      "source_id": 0,
      "full_name": "",
      "email": "importtest@noreply@src.opensuse.org",
      "avatar_url": "https://src.opensuse.org/avatars/10dc780b6dc535d772efc579e47b5acd",
      "html_url": "https://src.opensuse.org/importtest",
      "language": "",
      "is_admin": false,
      "last_login": "0001-01-01T00:00:00Z",
      "created": "2024-03-07T13:35:42+01:00",
      "restricted": false,
      "active": false,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "importtest"
    },
    "name": "nodejs-common",
    "full_name": "importtest/nodejs-common",
    "description": "",
    "empty": false,
    "private": false,
    "fork": true,
    "template": false,
    "parent": {
      "id": 90520,
      "owner": {
        "id": 983,
        "login": "autogits",
        "login_name": "",
        "source_id": 0,
        "full_name": "",
        "email": "autogits@noreply@src.opensuse.org",
        "avatar_url": "https://src.opensuse.org/avatars/80a61ef3a14c3c22f0b8b1885d1a75d4",
        "html_url": "https://src.opensuse.org/autogits",
        "language": "",
        "is_admin": false,
        "last_login": "0001-01-01T00:00:00Z",
        "created": "2024-06-20T09:46:37+02:00",
        "restricted": false,
        "active": false,
        "prohibit_login": false,
        "location": "",
        "website": "",
        "description": "",
        "visibility": "public",
        "followers_count": 0,
        "following_count": 0,
        "starred_repos_count": 0,
        "username": "autogits"
      },
      "name": "nodejs-common",
      "full_name": "autogits/nodejs-common",
      "description": "",
      "empty": false,
      "private": false,
      "fork": true,
      "template": false,
      "parent": null,
      "mirror": false,
      "size": 96,
      "language": "",
      "languages_url": "https://src.opensuse.org/api/v1/repos/autogits/nodejs-common/languages",
      "html_url": "https://src.opensuse.org/autogits/nodejs-common",
      "url": "https://src.opensuse.org/api/v1/repos/autogits/nodejs-common",
      "link": "",
      "ssh_url": "gitea@src.opensuse.org:autogits/nodejs-common.git",
      "clone_url": "https://src.opensuse.org/autogits/nodejs-common.git",
      "original_url": "",
      "website": "",
      "stars_count": 0,
      "forks_count": 2,
      "watchers_count": 2,
      "open_issues_count": 0,
      "open_pr_counter": 0,
      "release_counter": 0,
      "default_branch": "factory",
      "archived": false,
      "created_at": "2024-07-01T13:29:03+02:00",
      "updated_at": "2024-07-01T13:29:03+02:00",
      "archived_at": "1970-01-01T01:00:00+01:00",
      "permissions": {
        "admin": false,
        "push": false,
        "pull": false
      },
      "has_issues": false,
      "has_wiki": false,
      "has_pull_requests": true,
      "has_projects": false,
      "projects_mode": "all",
      "has_releases": false,
      "has_packages": false,
      "has_actions": false,
      "ignore_whitespace_conflicts": false,
      "allow_merge_commits": true,
      "allow_rebase": true,
      "allow_rebase_explicit": true,
      "allow_squash_merge": true,
      "allow_fast_forward_only_merge": true,
      "allow_rebase_update": true,
      "default_delete_branch_after_merge": false,
      "default_merge_style": "merge",
      "default_allow_maintainer_edit": false,
      "avatar_url": "https://src.opensuse.org/",
      "internal": false,
      "mirror_interval": "",
      "object_format_name": "sha256",
      "mirror_updated": "0001-01-01T00:00:00Z",
      "repo_transfer": null
    },
    "mirror": false,
    "size": 111,
    "language": "",
    "languages_url": "https://src.opensuse.org/api/v1/repos/importtest/nodejs-common/languages",
    "html_url": "https://src.opensuse.org/importtest/nodejs-common",
    "url": "https://src.opensuse.org/api/v1/repos/importtest/nodejs-common",
    "link": "",
    "ssh_url": "gitea@src.opensuse.org:importtest/nodejs-common.git",
    "clone_url": "https://src.opensuse.org/importtest/nodejs-common.git",
    "original_url": "",
    "website": "",
    "stars_count": 0,
    "forks_count": 0,
    "watchers_count": 1,
    "open_issues_count": 0,
    "open_pr_counter": 0,
    "release_counter": 0,
    "default_branch": "factory",
    "archived": false,
    "created_at": "2024-08-22T18:03:46+02:00",
    "updated_at": "2024-08-22T18:13:15+02:00",
    "archived_at": "1970-01-01T01:00:00+01:00",
    "permissions": {
      "admin": false,
      "push": false,
      "pull": false
    },
    "has_issues": false,
    "has_wiki": false,
    "has_pull_requests": true,
    "has_projects": false,
    "projects_mode": "all",
    "has_releases": false,
    "has_packages": false,
    "has_actions": false,
    "ignore_whitespace_conflicts": false,
    "allow_merge_commits": true,
    "allow_rebase": true,
    "allow_rebase_explicit": true,
    "allow_squash_merge": true,
    "allow_fast_forward_only_merge": true,
    "allow_rebase_update": true,
    "default_delete_branch_after_merge": false,
    "default_merge_style": "merge",
    "default_allow_maintainer_edit": false,
    "avatar_url": "https://src.opensuse.org/",
    "internal": false,
    "mirror_interval": "",
    "object_format_name": "sha256",
    "mirror_updated": "0001-01-01T00:00:00Z",
    "repo_transfer": null
  },
  "sender": {
    "id": 129,
    "login": "adamm",
    "login_name": "",
    "source_id": 0,
    "full_name": "Adam Majer",
    "email": "adamm@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
    "html_url": "https://src.opensuse.org/adamm",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-07-21T16:43:48+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "adamm"
  }
}`

const createTagJSON = `{
  "sha": "691c91e5240f24f5a75393caf8a78826b8a6f9f272ab4faef024102739f0060a",
  "ref": "foobar",
  "ref_type": "tag",
  "repository": {
    "id": 90992,
    "owner": {
      "id": 939,
      "login": "importtest",
      "login_name": "",
      "source_id": 0,
      "full_name": "",
      "email": "importtest@noreply@src.opensuse.org",
      "avatar_url": "https://src.opensuse.org/avatars/10dc780b6dc535d772efc579e47b5acd",
      "html_url": "https://src.opensuse.org/importtest",
      "language": "",
      "is_admin": false,
      "last_login": "0001-01-01T00:00:00Z",
      "created": "2024-03-07T13:35:42+01:00",
      "restricted": false,
      "active": false,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "importtest"
    },
    "name": "nodejs-common",
    "full_name": "importtest/nodejs-common",
    "description": "",
    "empty": false,
    "private": false,
    "fork": true,
    "template": false,
    "parent": {
      "id": 90520,
      "owner": {
        "id": 983,
        "login": "autogits",
        "login_name": "",
        "source_id": 0,
        "full_name": "",
        "email": "autogits@noreply@src.opensuse.org",
        "avatar_url": "https://src.opensuse.org/avatars/80a61ef3a14c3c22f0b8b1885d1a75d4",
        "html_url": "https://src.opensuse.org/autogits",
        "language": "",
        "is_admin": false,
        "last_login": "0001-01-01T00:00:00Z",
        "created": "2024-06-20T09:46:37+02:00",
        "restricted": false,
        "active": false,
        "prohibit_login": false,
        "location": "",
        "website": "",
        "description": "",
        "visibility": "public",
        "followers_count": 0,
        "following_count": 0,
        "starred_repos_count": 0,
        "username": "autogits"
      },
      "name": "nodejs-common",
      "full_name": "autogits/nodejs-common",
      "description": "",
      "empty": false,
      "private": false,
      "fork": true,
      "template": false,
      "parent": null,
      "mirror": false,
      "size": 96,
      "language": "",
      "languages_url": "https://src.opensuse.org/api/v1/repos/autogits/nodejs-common/languages",
      "html_url": "https://src.opensuse.org/autogits/nodejs-common",
      "url": "https://src.opensuse.org/api/v1/repos/autogits/nodejs-common",
      "link": "",
      "ssh_url": "gitea@src.opensuse.org:autogits/nodejs-common.git",
      "clone_url": "https://src.opensuse.org/autogits/nodejs-common.git",
      "original_url": "",
      "website": "",
      "stars_count": 0,
      "forks_count": 2,
      "watchers_count": 2,
      "open_issues_count": 0,
      "open_pr_counter": 0,
      "release_counter": 0,
      "default_branch": "factory",
      "archived": false,
      "created_at": "2024-07-01T13:29:03+02:00",
      "updated_at": "2024-07-01T13:29:03+02:00",
      "archived_at": "1970-01-01T01:00:00+01:00",
      "permissions": {
        "admin": false,
        "push": false,
        "pull": false
      },
      "has_issues": false,
      "has_wiki": false,
      "has_pull_requests": true,
      "has_projects": false,
      "projects_mode": "all",
      "has_releases": false,
      "has_packages": false,
      "has_actions": false,
      "ignore_whitespace_conflicts": false,
      "allow_merge_commits": true,
      "allow_rebase": true,
      "allow_rebase_explicit": true,
      "allow_squash_merge": true,
      "allow_fast_forward_only_merge": true,
      "allow_rebase_update": true,
      "default_delete_branch_after_merge": false,
      "default_merge_style": "merge",
      "default_allow_maintainer_edit": false,
      "avatar_url": "https://src.opensuse.org/",
      "internal": false,
      "mirror_interval": "",
      "object_format_name": "sha256",
      "mirror_updated": "0001-01-01T00:00:00Z",
      "repo_transfer": null
    },
    "mirror": false,
    "size": 111,
    "language": "",
    "languages_url": "https://src.opensuse.org/api/v1/repos/importtest/nodejs-common/languages",
    "html_url": "https://src.opensuse.org/importtest/nodejs-common",
    "url": "https://src.opensuse.org/api/v1/repos/importtest/nodejs-common",
    "link": "",
    "ssh_url": "gitea@src.opensuse.org:importtest/nodejs-common.git",
    "clone_url": "https://src.opensuse.org/importtest/nodejs-common.git",
    "original_url": "",
    "website": "",
    "stars_count": 0,
    "forks_count": 0,
    "watchers_count": 1,
    "open_issues_count": 0,
    "open_pr_counter": 0,
    "release_counter": 0,
    "default_branch": "factory",
    "archived": false,
    "created_at": "2024-08-22T18:03:46+02:00",
    "updated_at": "2024-08-24T14:27:02+02:00",
    "archived_at": "1970-01-01T01:00:00+01:00",
    "permissions": {
      "admin": false,
      "push": false,
      "pull": false
    },
    "has_issues": false,
    "has_wiki": false,
    "has_pull_requests": true,
    "has_projects": false,
    "projects_mode": "all",
    "has_releases": false,
    "has_packages": false,
    "has_actions": false,
    "ignore_whitespace_conflicts": false,
    "allow_merge_commits": true,
    "allow_rebase": true,
    "allow_rebase_explicit": true,
    "allow_squash_merge": true,
    "allow_fast_forward_only_merge": true,
    "allow_rebase_update": true,
    "default_delete_branch_after_merge": false,
    "default_merge_style": "merge",
    "default_allow_maintainer_edit": false,
    "avatar_url": "https://src.opensuse.org/",
    "internal": false,
    "mirror_interval": "",
    "object_format_name": "sha256",
    "mirror_updated": "0001-01-01T00:00:00Z",
    "repo_transfer": null
  },
  "sender": {
    "id": 129,
    "login": "adamm",
    "login_name": "",
    "source_id": 0,
    "full_name": "Adam Majer",
    "email": "adamm@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
    "html_url": "https://src.opensuse.org/adamm",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-07-21T16:43:48+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "adamm"
  }
}`

const createIssueJSON = `{
  "action": "opened",
  "number": 1,
  "issue": {
    "id": 97139,
    "url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj/issues/1",
    "html_url": "https://src.opensuse.org/importtest/_ObsPrj/issues/1",
    "number": 1,
    "user": {
      "id": 129,
      "login": "adamm",
      "login_name": "f79f87ba6073af67d93d1afdf5ed4c9326032010c8002647f737a67d438232e8",
      "source_id": 9,
      "full_name": "Adam Majer",
      "email": "amajer@suse.com",
      "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
      "html_url": "https://src.opensuse.org/adamm",
      "language": "en-US",
      "is_admin": false,
      "last_login": "2024-08-23T23:13:43+02:00",
      "created": "2023-07-21T16:43:48+02:00",
      "restricted": false,
      "active": true,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "adamm"
    },
    "original_author": "",
    "original_author_id": 0,
    "title": "test",
    "body": "test",
    "ref": "",
    "assets": [],
    "labels": [],
    "milestone": null,
    "assignee": null,
    "assignees": null,
    "state": "open",
    "is_locked": false,
    "comments": 0,
    "created_at": "2024-08-24T21:51:47+02:00",
    "updated_at": "2024-08-24T21:51:47+02:00",
    "closed_at": null,
    "due_date": null,
    "pull_request": null,
    "repository": {
      "id": 90991,
      "name": "_ObsPrj",
      "owner": "importtest",
      "full_name": "importtest/_ObsPrj"
    },
    "pin_order": 0
  },
  "repository": {
    "id": 90991,
    "owner": {
      "id": 939,
      "login": "importtest",
      "login_name": "",
      "source_id": 0,
      "full_name": "",
      "email": "",
      "avatar_url": "https://src.opensuse.org/avatars/10dc780b6dc535d772efc579e47b5acd",
      "html_url": "https://src.opensuse.org/importtest",
      "language": "",
      "is_admin": false,
      "last_login": "0001-01-01T00:00:00Z",
      "created": "2024-03-07T13:35:42+01:00",
      "restricted": false,
      "active": false,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "importtest"
    },
    "name": "_ObsPrj",
    "full_name": "importtest/_ObsPrj",
    "description": "",
    "empty": false,
    "private": false,
    "fork": false,
    "template": false,
    "parent": null,
    "mirror": false,
    "size": 30,
    "language": "",
    "languages_url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj/languages",
    "html_url": "https://src.opensuse.org/importtest/_ObsPrj",
    "url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj",
    "link": "",
    "ssh_url": "gitea@src.opensuse.org:importtest/_ObsPrj.git",
    "clone_url": "https://src.opensuse.org/importtest/_ObsPrj.git",
    "original_url": "",
    "website": "",
    "stars_count": 0,
    "forks_count": 0,
    "watchers_count": 1,
    "open_issues_count": 0,
    "open_pr_counter": 0,
    "release_counter": 0,
    "default_branch": "main",
    "archived": false,
    "created_at": "2024-08-22T18:01:09+02:00",
    "updated_at": "2024-08-24T18:12:37+02:00",
    "archived_at": "1970-01-01T01:00:00+01:00",
    "permissions": {
      "admin": true,
      "push": true,
      "pull": true
    },
    "has_issues": true,
    "internal_tracker": {
      "enable_time_tracker": false,
      "allow_only_contributors_to_track_time": true,
      "enable_issue_dependencies": true
    },
    "has_wiki": true,
    "has_pull_requests": true,
    "has_projects": true,
    "projects_mode": "all",
    "has_releases": true,
    "has_packages": true,
    "has_actions": true,
    "ignore_whitespace_conflicts": false,
    "allow_merge_commits": true,
    "allow_rebase": true,
    "allow_rebase_explicit": true,
    "allow_squash_merge": true,
    "allow_fast_forward_only_merge": true,
    "allow_rebase_update": true,
    "default_delete_branch_after_merge": false,
    "default_merge_style": "merge",
    "default_allow_maintainer_edit": false,
    "avatar_url": "https://src.opensuse.org/",
    "internal": false,
    "mirror_interval": "",
    "object_format_name": "sha256",
    "mirror_updated": "0001-01-01T00:00:00Z",
    "repo_transfer": null
  },
  "sender": {
    "id": 129,
    "login": "adamm",
    "login_name": "",
    "source_id": 0,
    "full_name": "Adam Majer",
    "email": "adamm@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
    "html_url": "https://src.opensuse.org/adamm",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-07-21T16:43:48+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "adamm"
  },
  "commit_id": ""
}`

const issueAssignJSON = `{
  "action": "unassigned",
  "number": 1,
  "issue": {
    "id": 97139,
    "url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj/issues/1",
    "html_url": "https://src.opensuse.org/importtest/_ObsPrj/issues/1",
    "number": 1,
    "user": {
      "id": 129,
      "login": "adamm",
      "login_name": "f79f87ba6073af67d93d1afdf5ed4c9326032010c8002647f737a67d438232e8",
      "source_id": 9,
      "full_name": "Adam Majer",
      "email": "amajer@suse.com",
      "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
      "html_url": "https://src.opensuse.org/adamm",
      "language": "en-US",
      "is_admin": false,
      "last_login": "2024-08-23T23:13:43+02:00",
      "created": "2023-07-21T16:43:48+02:00",
      "restricted": false,
      "active": true,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "adamm"
    },
    "original_author": "",
    "original_author_id": 0,
    "title": "test",
    "body": "test 2",
    "ref": "",
    "assets": [],
    "labels": [],
    "milestone": null,
    "assignee": null,
    "assignees": null,
    "state": "closed",
    "is_locked": false,
    "comments": 1,
    "created_at": "2024-08-24T21:51:47+02:00",
    "updated_at": "2024-08-24T22:07:40+02:00",
    "closed_at": "2024-08-24T22:06:20+02:00",
    "due_date": null,
    "pull_request": null,
    "repository": {
      "id": 90991,
      "name": "_ObsPrj",
      "owner": "importtest",
      "full_name": "importtest/_ObsPrj"
    },
    "pin_order": 0
  },
  "repository": {
    "id": 90991,
    "owner": {
      "id": 939,
      "login": "importtest",
      "login_name": "",
      "source_id": 0,
      "full_name": "",
      "email": "",
      "avatar_url": "https://src.opensuse.org/avatars/10dc780b6dc535d772efc579e47b5acd",
      "html_url": "https://src.opensuse.org/importtest",
      "language": "",
      "is_admin": false,
      "last_login": "0001-01-01T00:00:00Z",
      "created": "2024-03-07T13:35:42+01:00",
      "restricted": false,
      "active": false,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "importtest"
    },
    "name": "_ObsPrj",
    "full_name": "importtest/_ObsPrj",
    "description": "",
    "empty": false,
    "private": false,
    "fork": false,
    "template": false,
    "parent": null,
    "mirror": false,
    "size": 30,
    "language": "",
    "languages_url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj/languages",
    "html_url": "https://src.opensuse.org/importtest/_ObsPrj",
    "url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj",
    "link": "",
    "ssh_url": "gitea@src.opensuse.org:importtest/_ObsPrj.git",
    "clone_url": "https://src.opensuse.org/importtest/_ObsPrj.git",
    "original_url": "",
    "website": "",
    "stars_count": 0,
    "forks_count": 0,
    "watchers_count": 1,
    "open_issues_count": 0,
    "open_pr_counter": 0,
    "release_counter": 0,
    "default_branch": "main",
    "archived": false,
    "created_at": "2024-08-22T18:01:09+02:00",
    "updated_at": "2024-08-24T18:12:37+02:00",
    "archived_at": "1970-01-01T01:00:00+01:00",
    "permissions": {
      "admin": true,
      "push": true,
      "pull": true
    },
    "has_issues": true,
    "internal_tracker": {
      "enable_time_tracker": false,
      "allow_only_contributors_to_track_time": true,
      "enable_issue_dependencies": true
    },
    "has_wiki": true,
    "has_pull_requests": true,
    "has_projects": true,
    "projects_mode": "all",
    "has_releases": true,
    "has_packages": true,
    "has_actions": true,
    "ignore_whitespace_conflicts": false,
    "allow_merge_commits": true,
    "allow_rebase": true,
    "allow_rebase_explicit": true,
    "allow_squash_merge": true,
    "allow_fast_forward_only_merge": true,
    "allow_rebase_update": true,
    "default_delete_branch_after_merge": false,
    "default_merge_style": "merge",
    "default_allow_maintainer_edit": false,
    "avatar_url": "https://src.opensuse.org/",
    "internal": false,
    "mirror_interval": "",
    "object_format_name": "sha256",
    "mirror_updated": "0001-01-01T00:00:00Z",
    "repo_transfer": null
  },
  "sender": {
    "id": 129,
    "login": "adamm",
    "login_name": "",
    "source_id": 0,
    "full_name": "Adam Majer",
    "email": "adamm@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
    "html_url": "https://src.opensuse.org/adamm",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-07-21T16:43:48+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "adamm"
  },
  "commit_id": ""
}`

const requestedReviewJSON = `{
  "action": "review_requested",
  "number": 2,
  "pull_request": {
    "id": 547,
    "url": "https://src.opensuse.org/importtest/_ObsPrj/pulls/2",
    "number": 2,
    "user": {
      "id": 129,
      "login": "adamm",
      "login_name": "",
      "source_id": 0,
      "full_name": "Adam Majer",
      "email": "adamm@noreply@src.opensuse.org",
      "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
      "html_url": "https://src.opensuse.org/adamm",
      "language": "",
      "is_admin": false,
      "last_login": "0001-01-01T00:00:00Z",
      "created": "2023-07-21T16:43:48+02:00",
      "restricted": false,
      "active": false,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "adamm"
    },
    "title": "Update test",
    "body": "Edit",
    "labels": [],
    "milestone": null,
    "assignee": null,
    "assignees": null,
    "requested_reviewers": [
      {
        "id": 1008,
        "login": "autogits_obs_staging_bot",
        "login_name": "",
        "source_id": 0,
        "full_name": "Autogits StagingBot",
        "email": "autogits_obs_staging_bot@noreply@src.opensuse.org",
        "avatar_url": "https://src.opensuse.org/avatar/b8f40091fbd0a1f1b9e54f539dcdc783",
        "html_url": "https://src.opensuse.org/autogits_obs_staging_bot",
        "language": "",
        "is_admin": false,
        "last_login": "0001-01-01T00:00:00Z",
        "created": "2024-07-06T14:31:34+02:00",
        "restricted": false,
        "active": false,
        "prohibit_login": false,
        "location": "",
        "website": "",
        "description": "",
        "visibility": "public",
        "followers_count": 0,
        "following_count": 0,
        "starred_repos_count": 0,
        "username": "autogits_obs_staging_bot"
      }
    ],
    "state": "open",
    "draft": false,
    "is_locked": false,
    "comments": 0,
    "review_comments": 0,
    "additions": 1,
    "deletions": 1,
    "changed_files": 1,
    "html_url": "https://src.opensuse.org/importtest/_ObsPrj/pulls/2",
    "diff_url": "https://src.opensuse.org/importtest/_ObsPrj/pulls/2.diff",
    "patch_url": "https://src.opensuse.org/importtest/_ObsPrj/pulls/2.patch",
    "mergeable": true,
    "merged": false,
    "merged_at": null,
    "merge_commit_sha": null,
    "merged_by": null,
    "allow_maintainer_edit": false,
    "base": {
      "label": "main",
      "ref": "main",
      "sha": "c775ee91073b23bd4c2f9fd44d73976dae31b8ee3ab08eb2924fefff2bbd53ea",
      "repo_id": 90991,
      "repo": {
        "id": 90991,
        "owner": {
          "id": 939,
          "login": "importtest",
          "login_name": "",
          "source_id": 0,
          "full_name": "",
          "email": "",
          "avatar_url": "https://src.opensuse.org/avatars/10dc780b6dc535d772efc579e47b5acd",
          "html_url": "https://src.opensuse.org/importtest",
          "language": "",
          "is_admin": false,
          "last_login": "0001-01-01T00:00:00Z",
          "created": "2024-03-07T13:35:42+01:00",
          "restricted": false,
          "active": false,
          "prohibit_login": false,
          "location": "",
          "website": "",
          "description": "",
          "visibility": "public",
          "followers_count": 0,
          "following_count": 0,
          "starred_repos_count": 0,
          "username": "importtest"
        },
        "name": "_ObsPrj",
        "full_name": "importtest/_ObsPrj",
        "description": "",
        "empty": false,
        "private": false,
        "fork": false,
        "template": false,
        "parent": null,
        "mirror": false,
        "size": 30,
        "language": "",
        "languages_url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj/languages",
        "html_url": "https://src.opensuse.org/importtest/_ObsPrj",
        "url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj",
        "link": "",
        "ssh_url": "gitea@src.opensuse.org:importtest/_ObsPrj.git",
        "clone_url": "https://src.opensuse.org/importtest/_ObsPrj.git",
        "original_url": "",
        "website": "",
        "stars_count": 0,
        "forks_count": 1,
        "watchers_count": 1,
        "open_issues_count": 0,
        "open_pr_counter": 1,
        "release_counter": 0,
        "default_branch": "main",
        "archived": false,
        "created_at": "2024-08-22T18:01:09+02:00",
        "updated_at": "2024-08-24T18:12:37+02:00",
        "archived_at": "1970-01-01T01:00:00+01:00",
        "permissions": {
          "admin": false,
          "push": false,
          "pull": true
        },
        "has_issues": true,
        "internal_tracker": {
          "enable_time_tracker": false,
          "allow_only_contributors_to_track_time": true,
          "enable_issue_dependencies": true
        },
        "has_wiki": true,
        "has_pull_requests": true,
        "has_projects": true,
        "projects_mode": "all",
        "has_releases": true,
        "has_packages": true,
        "has_actions": true,
        "ignore_whitespace_conflicts": false,
        "allow_merge_commits": true,
        "allow_rebase": true,
        "allow_rebase_explicit": true,
        "allow_squash_merge": true,
        "allow_fast_forward_only_merge": true,
        "allow_rebase_update": true,
        "default_delete_branch_after_merge": false,
        "default_merge_style": "merge",
        "default_allow_maintainer_edit": false,
        "avatar_url": "https://src.opensuse.org/",
        "internal": false,
        "mirror_interval": "",
        "object_format_name": "sha256",
        "mirror_updated": "0001-01-01T00:00:00Z",
        "repo_transfer": null
      }
    },
    "head": {
      "label": "main",
      "ref": "main",
      "sha": "9eefdde2579fb569db3c91210803727437ec87fef9b3a7b890fa6b13b9b18729",
      "repo_id": 91024,
      "repo": {
        "id": 91024,
        "owner": {
          "id": 129,
          "login": "adamm",
          "login_name": "",
          "source_id": 0,
          "full_name": "Adam Majer",
          "email": "adamm@noreply@src.opensuse.org",
          "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
          "html_url": "https://src.opensuse.org/adamm",
          "language": "",
          "is_admin": false,
          "last_login": "0001-01-01T00:00:00Z",
          "created": "2023-07-21T16:43:48+02:00",
          "restricted": false,
          "active": false,
          "prohibit_login": false,
          "location": "",
          "website": "",
          "description": "",
          "visibility": "public",
          "followers_count": 0,
          "following_count": 0,
          "starred_repos_count": 0,
          "username": "adamm"
        },
        "name": "_ObsPrj",
        "full_name": "adamm/_ObsPrj",
        "description": "",
        "empty": false,
        "private": false,
        "fork": true,
        "template": false,
        "parent": {
          "id": 90991,
          "owner": {
            "id": 939,
            "login": "importtest",
            "login_name": "",
            "source_id": 0,
            "full_name": "",
            "email": "",
            "avatar_url": "https://src.opensuse.org/avatars/10dc780b6dc535d772efc579e47b5acd",
            "html_url": "https://src.opensuse.org/importtest",
            "language": "",
            "is_admin": false,
            "last_login": "0001-01-01T00:00:00Z",
            "created": "2024-03-07T13:35:42+01:00",
            "restricted": false,
            "active": false,
            "prohibit_login": false,
            "location": "",
            "website": "",
            "description": "",
            "visibility": "public",
            "followers_count": 0,
            "following_count": 0,
            "starred_repos_count": 0,
            "username": "importtest"
          },
          "name": "_ObsPrj",
          "full_name": "importtest/_ObsPrj",
          "description": "",
          "empty": false,
          "private": false,
          "fork": false,
          "template": false,
          "parent": null,
          "mirror": false,
          "size": 30,
          "language": "",
          "languages_url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj/languages",
          "html_url": "https://src.opensuse.org/importtest/_ObsPrj",
          "url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj",
          "link": "",
          "ssh_url": "gitea@src.opensuse.org:importtest/_ObsPrj.git",
          "clone_url": "https://src.opensuse.org/importtest/_ObsPrj.git",
          "original_url": "",
          "website": "",
          "stars_count": 0,
          "forks_count": 1,
          "watchers_count": 1,
          "open_issues_count": 0,
          "open_pr_counter": 1,
          "release_counter": 0,
          "default_branch": "main",
          "archived": false,
          "created_at": "2024-08-22T18:01:09+02:00",
          "updated_at": "2024-08-24T18:12:37+02:00",
          "archived_at": "1970-01-01T01:00:00+01:00",
          "permissions": {
            "admin": false,
            "push": false,
            "pull": true
          },
          "has_issues": true,
          "internal_tracker": {
            "enable_time_tracker": false,
            "allow_only_contributors_to_track_time": true,
            "enable_issue_dependencies": true
          },
          "has_wiki": true,
          "has_pull_requests": true,
          "has_projects": true,
          "projects_mode": "all",
          "has_releases": true,
          "has_packages": true,
          "has_actions": true,
          "ignore_whitespace_conflicts": false,
          "allow_merge_commits": true,
          "allow_rebase": true,
          "allow_rebase_explicit": true,
          "allow_squash_merge": true,
          "allow_fast_forward_only_merge": true,
          "allow_rebase_update": true,
          "default_delete_branch_after_merge": false,
          "default_merge_style": "merge",
          "default_allow_maintainer_edit": false,
          "avatar_url": "https://src.opensuse.org/",
          "internal": false,
          "mirror_interval": "",
          "object_format_name": "sha256",
          "mirror_updated": "0001-01-01T00:00:00Z",
          "repo_transfer": null
        },
        "mirror": false,
        "size": 30,
        "language": "",
        "languages_url": "https://src.opensuse.org/api/v1/repos/adamm/_ObsPrj/languages",
        "html_url": "https://src.opensuse.org/adamm/_ObsPrj",
        "url": "https://src.opensuse.org/api/v1/repos/adamm/_ObsPrj",
        "link": "",
        "ssh_url": "gitea@src.opensuse.org:adamm/_ObsPrj.git",
        "clone_url": "https://src.opensuse.org/adamm/_ObsPrj.git",
        "original_url": "",
        "website": "",
        "stars_count": 0,
        "forks_count": 0,
        "watchers_count": 1,
        "open_issues_count": 0,
        "open_pr_counter": 0,
        "release_counter": 0,
        "default_branch": "main",
        "archived": false,
        "created_at": "2024-08-25T22:40:43+02:00",
        "updated_at": "2024-08-25T22:41:00+02:00",
        "archived_at": "1970-01-01T01:00:00+01:00",
        "permissions": {
          "admin": false,
          "push": false,
          "pull": true
        },
        "has_issues": false,
        "has_wiki": false,
        "has_pull_requests": true,
        "has_projects": false,
        "projects_mode": "all",
        "has_releases": false,
        "has_packages": false,
        "has_actions": false,
        "ignore_whitespace_conflicts": false,
        "allow_merge_commits": true,
        "allow_rebase": true,
        "allow_rebase_explicit": true,
        "allow_squash_merge": true,
        "allow_fast_forward_only_merge": true,
        "allow_rebase_update": true,
        "default_delete_branch_after_merge": false,
        "default_merge_style": "merge",
        "default_allow_maintainer_edit": false,
        "avatar_url": "https://src.opensuse.org/",
        "internal": false,
        "mirror_interval": "",
        "object_format_name": "sha256",
        "mirror_updated": "0001-01-01T00:00:00Z",
        "repo_transfer": null
      }
    },
    "merge_base": "c775ee91073b23bd4c2f9fd44d73976dae31b8ee3ab08eb2924fefff2bbd53ea",
    "due_date": null,
    "created_at": "2024-08-25T22:41:42+02:00",
    "updated_at": "2024-08-26T13:00:18+02:00",
    "closed_at": null,
    "pin_order": 0
  },
  "requested_reviewer": {
    "id": 1008,
    "login": "autogits_obs_staging_bot",
    "login_name": "",
    "source_id": 0,
    "full_name": "Autogits StagingBot",
    "email": "autogits_obs_staging_bot@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/b8f40091fbd0a1f1b9e54f539dcdc783",
    "html_url": "https://src.opensuse.org/autogits_obs_staging_bot",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2024-07-06T14:31:34+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "autogits_obs_staging_bot"
  },
  "repository": {
    "id": 90991,
    "owner": {
      "id": 939,
      "login": "importtest",
      "login_name": "",
      "source_id": 0,
      "full_name": "",
      "email": "",
      "avatar_url": "https://src.opensuse.org/avatars/10dc780b6dc535d772efc579e47b5acd",
      "html_url": "https://src.opensuse.org/importtest",
      "language": "",
      "is_admin": false,
      "last_login": "0001-01-01T00:00:00Z",
      "created": "2024-03-07T13:35:42+01:00",
      "restricted": false,
      "active": false,
      "prohibit_login": false,
      "location": "",
      "website": "",
      "description": "",
      "visibility": "public",
      "followers_count": 0,
      "following_count": 0,
      "starred_repos_count": 0,
      "username": "importtest"
    },
    "name": "_ObsPrj",
    "full_name": "importtest/_ObsPrj",
    "description": "",
    "empty": false,
    "private": false,
    "fork": false,
    "template": false,
    "parent": null,
    "mirror": false,
    "size": 30,
    "language": "",
    "languages_url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj/languages",
    "html_url": "https://src.opensuse.org/importtest/_ObsPrj",
    "url": "https://src.opensuse.org/api/v1/repos/importtest/_ObsPrj",
    "link": "",
    "ssh_url": "gitea@src.opensuse.org:importtest/_ObsPrj.git",
    "clone_url": "https://src.opensuse.org/importtest/_ObsPrj.git",
    "original_url": "",
    "website": "",
    "stars_count": 0,
    "forks_count": 1,
    "watchers_count": 1,
    "open_issues_count": 0,
    "open_pr_counter": 1,
    "release_counter": 0,
    "default_branch": "main",
    "archived": false,
    "created_at": "2024-08-22T18:01:09+02:00",
    "updated_at": "2024-08-24T18:12:37+02:00",
    "archived_at": "1970-01-01T01:00:00+01:00",
    "permissions": {
      "admin": true,
      "push": true,
      "pull": true
    },
    "has_issues": true,
    "internal_tracker": {
      "enable_time_tracker": false,
      "allow_only_contributors_to_track_time": true,
      "enable_issue_dependencies": true
    },
    "has_wiki": true,
    "has_pull_requests": true,
    "has_projects": true,
    "projects_mode": "all",
    "has_releases": true,
    "has_packages": true,
    "has_actions": true,
    "ignore_whitespace_conflicts": false,
    "allow_merge_commits": true,
    "allow_rebase": true,
    "allow_rebase_explicit": true,
    "allow_squash_merge": true,
    "allow_fast_forward_only_merge": true,
    "allow_rebase_update": true,
    "default_delete_branch_after_merge": false,
    "default_merge_style": "merge",
    "default_allow_maintainer_edit": false,
    "avatar_url": "https://src.opensuse.org/",
    "internal": false,
    "mirror_interval": "",
    "object_format_name": "sha256",
    "mirror_updated": "0001-01-01T00:00:00Z",
    "repo_transfer": null
  },
  "sender": {
    "id": 129,
    "login": "adamm",
    "login_name": "",
    "source_id": 0,
    "full_name": "Adam Majer",
    "email": "adamm@noreply@src.opensuse.org",
    "avatar_url": "https://src.opensuse.org/avatar/babb6ae054a709c238a4e9b0f2b53d53",
    "html_url": "https://src.opensuse.org/adamm",
    "language": "",
    "is_admin": false,
    "last_login": "0001-01-01T00:00:00Z",
    "created": "2023-07-21T16:43:48+02:00",
    "restricted": false,
    "active": false,
    "prohibit_login": false,
    "location": "",
    "website": "",
    "description": "",
    "visibility": "public",
    "followers_count": 0,
    "following_count": 0,
    "starred_repos_count": 0,
    "username": "adamm"
  },
  "commit_id": "",
  "review": null
}`
