// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewIssueCreateLabelParams creates a new IssueCreateLabelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueCreateLabelParams() *IssueCreateLabelParams {
	return &IssueCreateLabelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueCreateLabelParamsWithTimeout creates a new IssueCreateLabelParams object
// with the ability to set a timeout on a request.
func NewIssueCreateLabelParamsWithTimeout(timeout time.Duration) *IssueCreateLabelParams {
	return &IssueCreateLabelParams{
		timeout: timeout,
	}
}

// NewIssueCreateLabelParamsWithContext creates a new IssueCreateLabelParams object
// with the ability to set a context for a request.
func NewIssueCreateLabelParamsWithContext(ctx context.Context) *IssueCreateLabelParams {
	return &IssueCreateLabelParams{
		Context: ctx,
	}
}

// NewIssueCreateLabelParamsWithHTTPClient creates a new IssueCreateLabelParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueCreateLabelParamsWithHTTPClient(client *http.Client) *IssueCreateLabelParams {
	return &IssueCreateLabelParams{
		HTTPClient: client,
	}
}

/*
IssueCreateLabelParams contains all the parameters to send to the API endpoint

	for the issue create label operation.

	Typically these are written to a http.Request.
*/
type IssueCreateLabelParams struct {

	// Body.
	Body *models.CreateLabelOption

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue create label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueCreateLabelParams) WithDefaults() *IssueCreateLabelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue create label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueCreateLabelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue create label params
func (o *IssueCreateLabelParams) WithTimeout(timeout time.Duration) *IssueCreateLabelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue create label params
func (o *IssueCreateLabelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue create label params
func (o *IssueCreateLabelParams) WithContext(ctx context.Context) *IssueCreateLabelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue create label params
func (o *IssueCreateLabelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue create label params
func (o *IssueCreateLabelParams) WithHTTPClient(client *http.Client) *IssueCreateLabelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue create label params
func (o *IssueCreateLabelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the issue create label params
func (o *IssueCreateLabelParams) WithBody(body *models.CreateLabelOption) *IssueCreateLabelParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the issue create label params
func (o *IssueCreateLabelParams) SetBody(body *models.CreateLabelOption) {
	o.Body = body
}

// WithOwner adds the owner to the issue create label params
func (o *IssueCreateLabelParams) WithOwner(owner string) *IssueCreateLabelParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue create label params
func (o *IssueCreateLabelParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue create label params
func (o *IssueCreateLabelParams) WithRepo(repo string) *IssueCreateLabelParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue create label params
func (o *IssueCreateLabelParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueCreateLabelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
