// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueDeleteParams creates a new IssueDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueDeleteParams() *IssueDeleteParams {
	return &IssueDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueDeleteParamsWithTimeout creates a new IssueDeleteParams object
// with the ability to set a timeout on a request.
func NewIssueDeleteParamsWithTimeout(timeout time.Duration) *IssueDeleteParams {
	return &IssueDeleteParams{
		timeout: timeout,
	}
}

// NewIssueDeleteParamsWithContext creates a new IssueDeleteParams object
// with the ability to set a context for a request.
func NewIssueDeleteParamsWithContext(ctx context.Context) *IssueDeleteParams {
	return &IssueDeleteParams{
		Context: ctx,
	}
}

// NewIssueDeleteParamsWithHTTPClient creates a new IssueDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueDeleteParamsWithHTTPClient(client *http.Client) *IssueDeleteParams {
	return &IssueDeleteParams{
		HTTPClient: client,
	}
}

/*
IssueDeleteParams contains all the parameters to send to the API endpoint

	for the issue delete operation.

	Typically these are written to a http.Request.
*/
type IssueDeleteParams struct {

	/* Index.

	   index of issue to delete

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteParams) WithDefaults() *IssueDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue delete params
func (o *IssueDeleteParams) WithTimeout(timeout time.Duration) *IssueDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue delete params
func (o *IssueDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue delete params
func (o *IssueDeleteParams) WithContext(ctx context.Context) *IssueDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue delete params
func (o *IssueDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue delete params
func (o *IssueDeleteParams) WithHTTPClient(client *http.Client) *IssueDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue delete params
func (o *IssueDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue delete params
func (o *IssueDeleteParams) WithIndex(index int64) *IssueDeleteParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue delete params
func (o *IssueDeleteParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue delete params
func (o *IssueDeleteParams) WithOwner(owner string) *IssueDeleteParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue delete params
func (o *IssueDeleteParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue delete params
func (o *IssueDeleteParams) WithRepo(repo string) *IssueDeleteParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue delete params
func (o *IssueDeleteParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
