// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueDeleteSubscriptionParams creates a new IssueDeleteSubscriptionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueDeleteSubscriptionParams() *IssueDeleteSubscriptionParams {
	return &IssueDeleteSubscriptionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueDeleteSubscriptionParamsWithTimeout creates a new IssueDeleteSubscriptionParams object
// with the ability to set a timeout on a request.
func NewIssueDeleteSubscriptionParamsWithTimeout(timeout time.Duration) *IssueDeleteSubscriptionParams {
	return &IssueDeleteSubscriptionParams{
		timeout: timeout,
	}
}

// NewIssueDeleteSubscriptionParamsWithContext creates a new IssueDeleteSubscriptionParams object
// with the ability to set a context for a request.
func NewIssueDeleteSubscriptionParamsWithContext(ctx context.Context) *IssueDeleteSubscriptionParams {
	return &IssueDeleteSubscriptionParams{
		Context: ctx,
	}
}

// NewIssueDeleteSubscriptionParamsWithHTTPClient creates a new IssueDeleteSubscriptionParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueDeleteSubscriptionParamsWithHTTPClient(client *http.Client) *IssueDeleteSubscriptionParams {
	return &IssueDeleteSubscriptionParams{
		HTTPClient: client,
	}
}

/*
IssueDeleteSubscriptionParams contains all the parameters to send to the API endpoint

	for the issue delete subscription operation.

	Typically these are written to a http.Request.
*/
type IssueDeleteSubscriptionParams struct {

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* User.

	   user witch unsubscribe
	*/
	User string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue delete subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteSubscriptionParams) WithDefaults() *IssueDeleteSubscriptionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue delete subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteSubscriptionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) WithTimeout(timeout time.Duration) *IssueDeleteSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) WithContext(ctx context.Context) *IssueDeleteSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) WithHTTPClient(client *http.Client) *IssueDeleteSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) WithIndex(index int64) *IssueDeleteSubscriptionParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) WithOwner(owner string) *IssueDeleteSubscriptionParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) WithRepo(repo string) *IssueDeleteSubscriptionParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithUser adds the user to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) WithUser(user string) *IssueDeleteSubscriptionParams {
	o.SetUser(user)
	return o
}

// SetUser adds the user to the issue delete subscription params
func (o *IssueDeleteSubscriptionParams) SetUser(user string) {
	o.User = user
}

// WriteToRequest writes these params to a swagger request
func (o *IssueDeleteSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param user
	if err := r.SetPathParam("user", o.User); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
