// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueDeleteTimeParams creates a new IssueDeleteTimeParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueDeleteTimeParams() *IssueDeleteTimeParams {
	return &IssueDeleteTimeParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueDeleteTimeParamsWithTimeout creates a new IssueDeleteTimeParams object
// with the ability to set a timeout on a request.
func NewIssueDeleteTimeParamsWithTimeout(timeout time.Duration) *IssueDeleteTimeParams {
	return &IssueDeleteTimeParams{
		timeout: timeout,
	}
}

// NewIssueDeleteTimeParamsWithContext creates a new IssueDeleteTimeParams object
// with the ability to set a context for a request.
func NewIssueDeleteTimeParamsWithContext(ctx context.Context) *IssueDeleteTimeParams {
	return &IssueDeleteTimeParams{
		Context: ctx,
	}
}

// NewIssueDeleteTimeParamsWithHTTPClient creates a new IssueDeleteTimeParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueDeleteTimeParamsWithHTTPClient(client *http.Client) *IssueDeleteTimeParams {
	return &IssueDeleteTimeParams{
		HTTPClient: client,
	}
}

/*
IssueDeleteTimeParams contains all the parameters to send to the API endpoint

	for the issue delete time operation.

	Typically these are written to a http.Request.
*/
type IssueDeleteTimeParams struct {

	/* ID.

	   id of time to delete

	   Format: int64
	*/
	ID int64

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue delete time params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteTimeParams) WithDefaults() *IssueDeleteTimeParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue delete time params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueDeleteTimeParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue delete time params
func (o *IssueDeleteTimeParams) WithTimeout(timeout time.Duration) *IssueDeleteTimeParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue delete time params
func (o *IssueDeleteTimeParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue delete time params
func (o *IssueDeleteTimeParams) WithContext(ctx context.Context) *IssueDeleteTimeParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue delete time params
func (o *IssueDeleteTimeParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue delete time params
func (o *IssueDeleteTimeParams) WithHTTPClient(client *http.Client) *IssueDeleteTimeParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue delete time params
func (o *IssueDeleteTimeParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the issue delete time params
func (o *IssueDeleteTimeParams) WithID(id int64) *IssueDeleteTimeParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue delete time params
func (o *IssueDeleteTimeParams) SetID(id int64) {
	o.ID = id
}

// WithIndex adds the index to the issue delete time params
func (o *IssueDeleteTimeParams) WithIndex(index int64) *IssueDeleteTimeParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue delete time params
func (o *IssueDeleteTimeParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue delete time params
func (o *IssueDeleteTimeParams) WithOwner(owner string) *IssueDeleteTimeParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue delete time params
func (o *IssueDeleteTimeParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue delete time params
func (o *IssueDeleteTimeParams) WithRepo(repo string) *IssueDeleteTimeParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue delete time params
func (o *IssueDeleteTimeParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueDeleteTimeParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
