// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueGetCommentReactionsParams creates a new IssueGetCommentReactionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueGetCommentReactionsParams() *IssueGetCommentReactionsParams {
	return &IssueGetCommentReactionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueGetCommentReactionsParamsWithTimeout creates a new IssueGetCommentReactionsParams object
// with the ability to set a timeout on a request.
func NewIssueGetCommentReactionsParamsWithTimeout(timeout time.Duration) *IssueGetCommentReactionsParams {
	return &IssueGetCommentReactionsParams{
		timeout: timeout,
	}
}

// NewIssueGetCommentReactionsParamsWithContext creates a new IssueGetCommentReactionsParams object
// with the ability to set a context for a request.
func NewIssueGetCommentReactionsParamsWithContext(ctx context.Context) *IssueGetCommentReactionsParams {
	return &IssueGetCommentReactionsParams{
		Context: ctx,
	}
}

// NewIssueGetCommentReactionsParamsWithHTTPClient creates a new IssueGetCommentReactionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueGetCommentReactionsParamsWithHTTPClient(client *http.Client) *IssueGetCommentReactionsParams {
	return &IssueGetCommentReactionsParams{
		HTTPClient: client,
	}
}

/*
IssueGetCommentReactionsParams contains all the parameters to send to the API endpoint

	for the issue get comment reactions operation.

	Typically these are written to a http.Request.
*/
type IssueGetCommentReactionsParams struct {

	/* ID.

	   id of the comment to edit

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue get comment reactions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetCommentReactionsParams) WithDefaults() *IssueGetCommentReactionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue get comment reactions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetCommentReactionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) WithTimeout(timeout time.Duration) *IssueGetCommentReactionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) WithContext(ctx context.Context) *IssueGetCommentReactionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) WithHTTPClient(client *http.Client) *IssueGetCommentReactionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) WithID(id int64) *IssueGetCommentReactionsParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) WithOwner(owner string) *IssueGetCommentReactionsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) WithRepo(repo string) *IssueGetCommentReactionsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue get comment reactions params
func (o *IssueGetCommentReactionsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueGetCommentReactionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
