// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueGetCommentsParams creates a new IssueGetCommentsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueGetCommentsParams() *IssueGetCommentsParams {
	return &IssueGetCommentsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueGetCommentsParamsWithTimeout creates a new IssueGetCommentsParams object
// with the ability to set a timeout on a request.
func NewIssueGetCommentsParamsWithTimeout(timeout time.Duration) *IssueGetCommentsParams {
	return &IssueGetCommentsParams{
		timeout: timeout,
	}
}

// NewIssueGetCommentsParamsWithContext creates a new IssueGetCommentsParams object
// with the ability to set a context for a request.
func NewIssueGetCommentsParamsWithContext(ctx context.Context) *IssueGetCommentsParams {
	return &IssueGetCommentsParams{
		Context: ctx,
	}
}

// NewIssueGetCommentsParamsWithHTTPClient creates a new IssueGetCommentsParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueGetCommentsParamsWithHTTPClient(client *http.Client) *IssueGetCommentsParams {
	return &IssueGetCommentsParams{
		HTTPClient: client,
	}
}

/*
IssueGetCommentsParams contains all the parameters to send to the API endpoint

	for the issue get comments operation.

	Typically these are written to a http.Request.
*/
type IssueGetCommentsParams struct {

	/* Before.

	   if provided, only comments updated before the provided time are returned.

	   Format: date-time
	*/
	Before *strfmt.DateTime

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* Since.

	   if provided, only comments updated since the specified time are returned.

	   Format: date-time
	*/
	Since *strfmt.DateTime

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue get comments params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetCommentsParams) WithDefaults() *IssueGetCommentsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue get comments params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetCommentsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue get comments params
func (o *IssueGetCommentsParams) WithTimeout(timeout time.Duration) *IssueGetCommentsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue get comments params
func (o *IssueGetCommentsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue get comments params
func (o *IssueGetCommentsParams) WithContext(ctx context.Context) *IssueGetCommentsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue get comments params
func (o *IssueGetCommentsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue get comments params
func (o *IssueGetCommentsParams) WithHTTPClient(client *http.Client) *IssueGetCommentsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue get comments params
func (o *IssueGetCommentsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBefore adds the before to the issue get comments params
func (o *IssueGetCommentsParams) WithBefore(before *strfmt.DateTime) *IssueGetCommentsParams {
	o.SetBefore(before)
	return o
}

// SetBefore adds the before to the issue get comments params
func (o *IssueGetCommentsParams) SetBefore(before *strfmt.DateTime) {
	o.Before = before
}

// WithIndex adds the index to the issue get comments params
func (o *IssueGetCommentsParams) WithIndex(index int64) *IssueGetCommentsParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue get comments params
func (o *IssueGetCommentsParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue get comments params
func (o *IssueGetCommentsParams) WithOwner(owner string) *IssueGetCommentsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue get comments params
func (o *IssueGetCommentsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue get comments params
func (o *IssueGetCommentsParams) WithRepo(repo string) *IssueGetCommentsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue get comments params
func (o *IssueGetCommentsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithSince adds the since to the issue get comments params
func (o *IssueGetCommentsParams) WithSince(since *strfmt.DateTime) *IssueGetCommentsParams {
	o.SetSince(since)
	return o
}

// SetSince adds the since to the issue get comments params
func (o *IssueGetCommentsParams) SetSince(since *strfmt.DateTime) {
	o.Since = since
}

// WriteToRequest writes these params to a swagger request
func (o *IssueGetCommentsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Before != nil {

		// query param before
		var qrBefore strfmt.DateTime

		if o.Before != nil {
			qrBefore = *o.Before
		}
		qBefore := qrBefore.String()
		if qBefore != "" {

			if err := r.SetQueryParam("before", qBefore); err != nil {
				return err
			}
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if o.Since != nil {

		// query param since
		var qrSince strfmt.DateTime

		if o.Since != nil {
			qrSince = *o.Since
		}
		qSince := qrSince.String()
		if qSince != "" {

			if err := r.SetQueryParam("since", qSince); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
