// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueGetIssueParams creates a new IssueGetIssueParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueGetIssueParams() *IssueGetIssueParams {
	return &IssueGetIssueParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueGetIssueParamsWithTimeout creates a new IssueGetIssueParams object
// with the ability to set a timeout on a request.
func NewIssueGetIssueParamsWithTimeout(timeout time.Duration) *IssueGetIssueParams {
	return &IssueGetIssueParams{
		timeout: timeout,
	}
}

// NewIssueGetIssueParamsWithContext creates a new IssueGetIssueParams object
// with the ability to set a context for a request.
func NewIssueGetIssueParamsWithContext(ctx context.Context) *IssueGetIssueParams {
	return &IssueGetIssueParams{
		Context: ctx,
	}
}

// NewIssueGetIssueParamsWithHTTPClient creates a new IssueGetIssueParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueGetIssueParamsWithHTTPClient(client *http.Client) *IssueGetIssueParams {
	return &IssueGetIssueParams{
		HTTPClient: client,
	}
}

/*
IssueGetIssueParams contains all the parameters to send to the API endpoint

	for the issue get issue operation.

	Typically these are written to a http.Request.
*/
type IssueGetIssueParams struct {

	/* Index.

	   index of the issue to get

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue get issue params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetIssueParams) WithDefaults() *IssueGetIssueParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue get issue params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetIssueParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue get issue params
func (o *IssueGetIssueParams) WithTimeout(timeout time.Duration) *IssueGetIssueParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue get issue params
func (o *IssueGetIssueParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue get issue params
func (o *IssueGetIssueParams) WithContext(ctx context.Context) *IssueGetIssueParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue get issue params
func (o *IssueGetIssueParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue get issue params
func (o *IssueGetIssueParams) WithHTTPClient(client *http.Client) *IssueGetIssueParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue get issue params
func (o *IssueGetIssueParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue get issue params
func (o *IssueGetIssueParams) WithIndex(index int64) *IssueGetIssueParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue get issue params
func (o *IssueGetIssueParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue get issue params
func (o *IssueGetIssueParams) WithOwner(owner string) *IssueGetIssueParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue get issue params
func (o *IssueGetIssueParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue get issue params
func (o *IssueGetIssueParams) WithRepo(repo string) *IssueGetIssueParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue get issue params
func (o *IssueGetIssueParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueGetIssueParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
