// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewIssueGetMilestoneParams creates a new IssueGetMilestoneParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueGetMilestoneParams() *IssueGetMilestoneParams {
	return &IssueGetMilestoneParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueGetMilestoneParamsWithTimeout creates a new IssueGetMilestoneParams object
// with the ability to set a timeout on a request.
func NewIssueGetMilestoneParamsWithTimeout(timeout time.Duration) *IssueGetMilestoneParams {
	return &IssueGetMilestoneParams{
		timeout: timeout,
	}
}

// NewIssueGetMilestoneParamsWithContext creates a new IssueGetMilestoneParams object
// with the ability to set a context for a request.
func NewIssueGetMilestoneParamsWithContext(ctx context.Context) *IssueGetMilestoneParams {
	return &IssueGetMilestoneParams{
		Context: ctx,
	}
}

// NewIssueGetMilestoneParamsWithHTTPClient creates a new IssueGetMilestoneParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueGetMilestoneParamsWithHTTPClient(client *http.Client) *IssueGetMilestoneParams {
	return &IssueGetMilestoneParams{
		HTTPClient: client,
	}
}

/*
IssueGetMilestoneParams contains all the parameters to send to the API endpoint

	for the issue get milestone operation.

	Typically these are written to a http.Request.
*/
type IssueGetMilestoneParams struct {

	/* ID.

	   the milestone to get, identified by ID and if not available by name
	*/
	ID string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue get milestone params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetMilestoneParams) WithDefaults() *IssueGetMilestoneParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue get milestone params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueGetMilestoneParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue get milestone params
func (o *IssueGetMilestoneParams) WithTimeout(timeout time.Duration) *IssueGetMilestoneParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue get milestone params
func (o *IssueGetMilestoneParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue get milestone params
func (o *IssueGetMilestoneParams) WithContext(ctx context.Context) *IssueGetMilestoneParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue get milestone params
func (o *IssueGetMilestoneParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue get milestone params
func (o *IssueGetMilestoneParams) WithHTTPClient(client *http.Client) *IssueGetMilestoneParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue get milestone params
func (o *IssueGetMilestoneParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the issue get milestone params
func (o *IssueGetMilestoneParams) WithID(id string) *IssueGetMilestoneParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue get milestone params
func (o *IssueGetMilestoneParams) SetID(id string) {
	o.ID = id
}

// WithOwner adds the owner to the issue get milestone params
func (o *IssueGetMilestoneParams) WithOwner(owner string) *IssueGetMilestoneParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue get milestone params
func (o *IssueGetMilestoneParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue get milestone params
func (o *IssueGetMilestoneParams) WithRepo(repo string) *IssueGetMilestoneParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue get milestone params
func (o *IssueGetMilestoneParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueGetMilestoneParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
