// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewIssuePostIssueReactionParams creates a new IssuePostIssueReactionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssuePostIssueReactionParams() *IssuePostIssueReactionParams {
	return &IssuePostIssueReactionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssuePostIssueReactionParamsWithTimeout creates a new IssuePostIssueReactionParams object
// with the ability to set a timeout on a request.
func NewIssuePostIssueReactionParamsWithTimeout(timeout time.Duration) *IssuePostIssueReactionParams {
	return &IssuePostIssueReactionParams{
		timeout: timeout,
	}
}

// NewIssuePostIssueReactionParamsWithContext creates a new IssuePostIssueReactionParams object
// with the ability to set a context for a request.
func NewIssuePostIssueReactionParamsWithContext(ctx context.Context) *IssuePostIssueReactionParams {
	return &IssuePostIssueReactionParams{
		Context: ctx,
	}
}

// NewIssuePostIssueReactionParamsWithHTTPClient creates a new IssuePostIssueReactionParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssuePostIssueReactionParamsWithHTTPClient(client *http.Client) *IssuePostIssueReactionParams {
	return &IssuePostIssueReactionParams{
		HTTPClient: client,
	}
}

/*
IssuePostIssueReactionParams contains all the parameters to send to the API endpoint

	for the issue post issue reaction operation.

	Typically these are written to a http.Request.
*/
type IssuePostIssueReactionParams struct {

	// Content.
	Content *models.EditReactionOption

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue post issue reaction params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssuePostIssueReactionParams) WithDefaults() *IssuePostIssueReactionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue post issue reaction params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssuePostIssueReactionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) WithTimeout(timeout time.Duration) *IssuePostIssueReactionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) WithContext(ctx context.Context) *IssuePostIssueReactionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) WithHTTPClient(client *http.Client) *IssuePostIssueReactionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContent adds the content to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) WithContent(content *models.EditReactionOption) *IssuePostIssueReactionParams {
	o.SetContent(content)
	return o
}

// SetContent adds the content to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) SetContent(content *models.EditReactionOption) {
	o.Content = content
}

// WithIndex adds the index to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) WithIndex(index int64) *IssuePostIssueReactionParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) WithOwner(owner string) *IssuePostIssueReactionParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) WithRepo(repo string) *IssuePostIssueReactionParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue post issue reaction params
func (o *IssuePostIssueReactionParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssuePostIssueReactionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Content != nil {
		if err := r.SetBodyParam(o.Content); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
