// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueRemoveLabelParams creates a new IssueRemoveLabelParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueRemoveLabelParams() *IssueRemoveLabelParams {
	return &IssueRemoveLabelParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueRemoveLabelParamsWithTimeout creates a new IssueRemoveLabelParams object
// with the ability to set a timeout on a request.
func NewIssueRemoveLabelParamsWithTimeout(timeout time.Duration) *IssueRemoveLabelParams {
	return &IssueRemoveLabelParams{
		timeout: timeout,
	}
}

// NewIssueRemoveLabelParamsWithContext creates a new IssueRemoveLabelParams object
// with the ability to set a context for a request.
func NewIssueRemoveLabelParamsWithContext(ctx context.Context) *IssueRemoveLabelParams {
	return &IssueRemoveLabelParams{
		Context: ctx,
	}
}

// NewIssueRemoveLabelParamsWithHTTPClient creates a new IssueRemoveLabelParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueRemoveLabelParamsWithHTTPClient(client *http.Client) *IssueRemoveLabelParams {
	return &IssueRemoveLabelParams{
		HTTPClient: client,
	}
}

/*
IssueRemoveLabelParams contains all the parameters to send to the API endpoint

	for the issue remove label operation.

	Typically these are written to a http.Request.
*/
type IssueRemoveLabelParams struct {

	/* ID.

	   id of the label to remove

	   Format: int64
	*/
	ID int64

	/* Index.

	   index of the issue

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue remove label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueRemoveLabelParams) WithDefaults() *IssueRemoveLabelParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue remove label params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueRemoveLabelParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue remove label params
func (o *IssueRemoveLabelParams) WithTimeout(timeout time.Duration) *IssueRemoveLabelParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue remove label params
func (o *IssueRemoveLabelParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue remove label params
func (o *IssueRemoveLabelParams) WithContext(ctx context.Context) *IssueRemoveLabelParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue remove label params
func (o *IssueRemoveLabelParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue remove label params
func (o *IssueRemoveLabelParams) WithHTTPClient(client *http.Client) *IssueRemoveLabelParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue remove label params
func (o *IssueRemoveLabelParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the issue remove label params
func (o *IssueRemoveLabelParams) WithID(id int64) *IssueRemoveLabelParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the issue remove label params
func (o *IssueRemoveLabelParams) SetID(id int64) {
	o.ID = id
}

// WithIndex adds the index to the issue remove label params
func (o *IssueRemoveLabelParams) WithIndex(index int64) *IssueRemoveLabelParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue remove label params
func (o *IssueRemoveLabelParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue remove label params
func (o *IssueRemoveLabelParams) WithOwner(owner string) *IssueRemoveLabelParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue remove label params
func (o *IssueRemoveLabelParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue remove label params
func (o *IssueRemoveLabelParams) WithRepo(repo string) *IssueRemoveLabelParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue remove label params
func (o *IssueRemoveLabelParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueRemoveLabelParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
