// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueStartStopWatchParams creates a new IssueStartStopWatchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueStartStopWatchParams() *IssueStartStopWatchParams {
	return &IssueStartStopWatchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueStartStopWatchParamsWithTimeout creates a new IssueStartStopWatchParams object
// with the ability to set a timeout on a request.
func NewIssueStartStopWatchParamsWithTimeout(timeout time.Duration) *IssueStartStopWatchParams {
	return &IssueStartStopWatchParams{
		timeout: timeout,
	}
}

// NewIssueStartStopWatchParamsWithContext creates a new IssueStartStopWatchParams object
// with the ability to set a context for a request.
func NewIssueStartStopWatchParamsWithContext(ctx context.Context) *IssueStartStopWatchParams {
	return &IssueStartStopWatchParams{
		Context: ctx,
	}
}

// NewIssueStartStopWatchParamsWithHTTPClient creates a new IssueStartStopWatchParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueStartStopWatchParamsWithHTTPClient(client *http.Client) *IssueStartStopWatchParams {
	return &IssueStartStopWatchParams{
		HTTPClient: client,
	}
}

/*
IssueStartStopWatchParams contains all the parameters to send to the API endpoint

	for the issue start stop watch operation.

	Typically these are written to a http.Request.
*/
type IssueStartStopWatchParams struct {

	/* Index.

	   index of the issue to create the stopwatch on

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue start stop watch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueStartStopWatchParams) WithDefaults() *IssueStartStopWatchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue start stop watch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueStartStopWatchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue start stop watch params
func (o *IssueStartStopWatchParams) WithTimeout(timeout time.Duration) *IssueStartStopWatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue start stop watch params
func (o *IssueStartStopWatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue start stop watch params
func (o *IssueStartStopWatchParams) WithContext(ctx context.Context) *IssueStartStopWatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue start stop watch params
func (o *IssueStartStopWatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue start stop watch params
func (o *IssueStartStopWatchParams) WithHTTPClient(client *http.Client) *IssueStartStopWatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue start stop watch params
func (o *IssueStartStopWatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue start stop watch params
func (o *IssueStartStopWatchParams) WithIndex(index int64) *IssueStartStopWatchParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue start stop watch params
func (o *IssueStartStopWatchParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue start stop watch params
func (o *IssueStartStopWatchParams) WithOwner(owner string) *IssueStartStopWatchParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue start stop watch params
func (o *IssueStartStopWatchParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue start stop watch params
func (o *IssueStartStopWatchParams) WithRepo(repo string) *IssueStartStopWatchParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue start stop watch params
func (o *IssueStartStopWatchParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueStartStopWatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
