// Code generated by go-swagger; DO NOT EDIT.

package issue

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIssueStopStopWatchParams creates a new IssueStopStopWatchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIssueStopStopWatchParams() *IssueStopStopWatchParams {
	return &IssueStopStopWatchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIssueStopStopWatchParamsWithTimeout creates a new IssueStopStopWatchParams object
// with the ability to set a timeout on a request.
func NewIssueStopStopWatchParamsWithTimeout(timeout time.Duration) *IssueStopStopWatchParams {
	return &IssueStopStopWatchParams{
		timeout: timeout,
	}
}

// NewIssueStopStopWatchParamsWithContext creates a new IssueStopStopWatchParams object
// with the ability to set a context for a request.
func NewIssueStopStopWatchParamsWithContext(ctx context.Context) *IssueStopStopWatchParams {
	return &IssueStopStopWatchParams{
		Context: ctx,
	}
}

// NewIssueStopStopWatchParamsWithHTTPClient creates a new IssueStopStopWatchParams object
// with the ability to set a custom HTTPClient for a request.
func NewIssueStopStopWatchParamsWithHTTPClient(client *http.Client) *IssueStopStopWatchParams {
	return &IssueStopStopWatchParams{
		HTTPClient: client,
	}
}

/*
IssueStopStopWatchParams contains all the parameters to send to the API endpoint

	for the issue stop stop watch operation.

	Typically these are written to a http.Request.
*/
type IssueStopStopWatchParams struct {

	/* Index.

	   index of the issue to stop the stopwatch on

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the issue stop stop watch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueStopStopWatchParams) WithDefaults() *IssueStopStopWatchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the issue stop stop watch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IssueStopStopWatchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the issue stop stop watch params
func (o *IssueStopStopWatchParams) WithTimeout(timeout time.Duration) *IssueStopStopWatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the issue stop stop watch params
func (o *IssueStopStopWatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the issue stop stop watch params
func (o *IssueStopStopWatchParams) WithContext(ctx context.Context) *IssueStopStopWatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the issue stop stop watch params
func (o *IssueStopStopWatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the issue stop stop watch params
func (o *IssueStopStopWatchParams) WithHTTPClient(client *http.Client) *IssueStopStopWatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the issue stop stop watch params
func (o *IssueStopStopWatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the issue stop stop watch params
func (o *IssueStopStopWatchParams) WithIndex(index int64) *IssueStopStopWatchParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the issue stop stop watch params
func (o *IssueStopStopWatchParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the issue stop stop watch params
func (o *IssueStopStopWatchParams) WithOwner(owner string) *IssueStopStopWatchParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the issue stop stop watch params
func (o *IssueStopStopWatchParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the issue stop stop watch params
func (o *IssueStopStopWatchParams) WithRepo(repo string) *IssueStopStopWatchParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the issue stop stop watch params
func (o *IssueStopStopWatchParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *IssueStopStopWatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
