// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// GetOrgVariablesListReader is a Reader for the GetOrgVariablesList structure.
type GetOrgVariablesListReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetOrgVariablesListReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetOrgVariablesListOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetOrgVariablesListBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewGetOrgVariablesListNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /orgs/{org}/actions/variables] getOrgVariablesList", response, response.Code())
	}
}

// NewGetOrgVariablesListOK creates a GetOrgVariablesListOK with default headers values
func NewGetOrgVariablesListOK() *GetOrgVariablesListOK {
	return &GetOrgVariablesListOK{}
}

/*
GetOrgVariablesListOK describes a response with status code 200, with default header values.

VariableList
*/
type GetOrgVariablesListOK struct {
	Payload []*models.ActionVariable
}

// IsSuccess returns true when this get org variables list o k response has a 2xx status code
func (o *GetOrgVariablesListOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get org variables list o k response has a 3xx status code
func (o *GetOrgVariablesListOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get org variables list o k response has a 4xx status code
func (o *GetOrgVariablesListOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get org variables list o k response has a 5xx status code
func (o *GetOrgVariablesListOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get org variables list o k response a status code equal to that given
func (o *GetOrgVariablesListOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get org variables list o k response
func (o *GetOrgVariablesListOK) Code() int {
	return 200
}

func (o *GetOrgVariablesListOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables][%d] getOrgVariablesListOK %s", 200, payload)
}

func (o *GetOrgVariablesListOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables][%d] getOrgVariablesListOK %s", 200, payload)
}

func (o *GetOrgVariablesListOK) GetPayload() []*models.ActionVariable {
	return o.Payload
}

func (o *GetOrgVariablesListOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetOrgVariablesListBadRequest creates a GetOrgVariablesListBadRequest with default headers values
func NewGetOrgVariablesListBadRequest() *GetOrgVariablesListBadRequest {
	return &GetOrgVariablesListBadRequest{}
}

/*
GetOrgVariablesListBadRequest describes a response with status code 400, with default header values.

APIError is error format response
*/
type GetOrgVariablesListBadRequest struct {
	Message string
	URL     string
}

// IsSuccess returns true when this get org variables list bad request response has a 2xx status code
func (o *GetOrgVariablesListBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get org variables list bad request response has a 3xx status code
func (o *GetOrgVariablesListBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get org variables list bad request response has a 4xx status code
func (o *GetOrgVariablesListBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this get org variables list bad request response has a 5xx status code
func (o *GetOrgVariablesListBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this get org variables list bad request response a status code equal to that given
func (o *GetOrgVariablesListBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the get org variables list bad request response
func (o *GetOrgVariablesListBadRequest) Code() int {
	return 400
}

func (o *GetOrgVariablesListBadRequest) Error() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables][%d] getOrgVariablesListBadRequest", 400)
}

func (o *GetOrgVariablesListBadRequest) String() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables][%d] getOrgVariablesListBadRequest", 400)
}

func (o *GetOrgVariablesListBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header message
	hdrMessage := response.GetHeader("message")

	if hdrMessage != "" {
		o.Message = hdrMessage
	}

	// hydrates response header url
	hdrURL := response.GetHeader("url")

	if hdrURL != "" {
		o.URL = hdrURL
	}

	return nil
}

// NewGetOrgVariablesListNotFound creates a GetOrgVariablesListNotFound with default headers values
func NewGetOrgVariablesListNotFound() *GetOrgVariablesListNotFound {
	return &GetOrgVariablesListNotFound{}
}

/*
GetOrgVariablesListNotFound describes a response with status code 404, with default header values.

APINotFound is a not found empty response
*/
type GetOrgVariablesListNotFound struct {
}

// IsSuccess returns true when this get org variables list not found response has a 2xx status code
func (o *GetOrgVariablesListNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get org variables list not found response has a 3xx status code
func (o *GetOrgVariablesListNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get org variables list not found response has a 4xx status code
func (o *GetOrgVariablesListNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this get org variables list not found response has a 5xx status code
func (o *GetOrgVariablesListNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this get org variables list not found response a status code equal to that given
func (o *GetOrgVariablesListNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the get org variables list not found response
func (o *GetOrgVariablesListNotFound) Code() int {
	return 404
}

func (o *GetOrgVariablesListNotFound) Error() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables][%d] getOrgVariablesListNotFound", 404)
}

func (o *GetOrgVariablesListNotFound) String() string {
	return fmt.Sprintf("[GET /orgs/{org}/actions/variables][%d] getOrgVariablesListNotFound", 404)
}

func (o *GetOrgVariablesListNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}
