// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewOrgGetParams creates a new OrgGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgGetParams() *OrgGetParams {
	return &OrgGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgGetParamsWithTimeout creates a new OrgGetParams object
// with the ability to set a timeout on a request.
func NewOrgGetParamsWithTimeout(timeout time.Duration) *OrgGetParams {
	return &OrgGetParams{
		timeout: timeout,
	}
}

// NewOrgGetParamsWithContext creates a new OrgGetParams object
// with the ability to set a context for a request.
func NewOrgGetParamsWithContext(ctx context.Context) *OrgGetParams {
	return &OrgGetParams{
		Context: ctx,
	}
}

// NewOrgGetParamsWithHTTPClient creates a new OrgGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgGetParamsWithHTTPClient(client *http.Client) *OrgGetParams {
	return &OrgGetParams{
		HTTPClient: client,
	}
}

/*
OrgGetParams contains all the parameters to send to the API endpoint

	for the org get operation.

	Typically these are written to a http.Request.
*/
type OrgGetParams struct {

	/* Org.

	   name of the organization to get
	*/
	Org string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgGetParams) WithDefaults() *OrgGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org get params
func (o *OrgGetParams) WithTimeout(timeout time.Duration) *OrgGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org get params
func (o *OrgGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org get params
func (o *OrgGetParams) WithContext(ctx context.Context) *OrgGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org get params
func (o *OrgGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org get params
func (o *OrgGetParams) WithHTTPClient(client *http.Client) *OrgGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org get params
func (o *OrgGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrg adds the org to the org get params
func (o *OrgGetParams) WithOrg(org string) *OrgGetParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org get params
func (o *OrgGetParams) SetOrg(org string) {
	o.Org = org
}

// WriteToRequest writes these params to a swagger request
func (o *OrgGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
