// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewOrgListActivityFeedsParams creates a new OrgListActivityFeedsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgListActivityFeedsParams() *OrgListActivityFeedsParams {
	return &OrgListActivityFeedsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgListActivityFeedsParamsWithTimeout creates a new OrgListActivityFeedsParams object
// with the ability to set a timeout on a request.
func NewOrgListActivityFeedsParamsWithTimeout(timeout time.Duration) *OrgListActivityFeedsParams {
	return &OrgListActivityFeedsParams{
		timeout: timeout,
	}
}

// NewOrgListActivityFeedsParamsWithContext creates a new OrgListActivityFeedsParams object
// with the ability to set a context for a request.
func NewOrgListActivityFeedsParamsWithContext(ctx context.Context) *OrgListActivityFeedsParams {
	return &OrgListActivityFeedsParams{
		Context: ctx,
	}
}

// NewOrgListActivityFeedsParamsWithHTTPClient creates a new OrgListActivityFeedsParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgListActivityFeedsParamsWithHTTPClient(client *http.Client) *OrgListActivityFeedsParams {
	return &OrgListActivityFeedsParams{
		HTTPClient: client,
	}
}

/*
OrgListActivityFeedsParams contains all the parameters to send to the API endpoint

	for the org list activity feeds operation.

	Typically these are written to a http.Request.
*/
type OrgListActivityFeedsParams struct {

	/* Date.

	   the date of the activities to be found

	   Format: date
	*/
	Date *strfmt.Date

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Org.

	   name of the org
	*/
	Org string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org list activity feeds params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgListActivityFeedsParams) WithDefaults() *OrgListActivityFeedsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org list activity feeds params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgListActivityFeedsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org list activity feeds params
func (o *OrgListActivityFeedsParams) WithTimeout(timeout time.Duration) *OrgListActivityFeedsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org list activity feeds params
func (o *OrgListActivityFeedsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org list activity feeds params
func (o *OrgListActivityFeedsParams) WithContext(ctx context.Context) *OrgListActivityFeedsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org list activity feeds params
func (o *OrgListActivityFeedsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org list activity feeds params
func (o *OrgListActivityFeedsParams) WithHTTPClient(client *http.Client) *OrgListActivityFeedsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org list activity feeds params
func (o *OrgListActivityFeedsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDate adds the date to the org list activity feeds params
func (o *OrgListActivityFeedsParams) WithDate(date *strfmt.Date) *OrgListActivityFeedsParams {
	o.SetDate(date)
	return o
}

// SetDate adds the date to the org list activity feeds params
func (o *OrgListActivityFeedsParams) SetDate(date *strfmt.Date) {
	o.Date = date
}

// WithLimit adds the limit to the org list activity feeds params
func (o *OrgListActivityFeedsParams) WithLimit(limit *int64) *OrgListActivityFeedsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the org list activity feeds params
func (o *OrgListActivityFeedsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOrg adds the org to the org list activity feeds params
func (o *OrgListActivityFeedsParams) WithOrg(org string) *OrgListActivityFeedsParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the org list activity feeds params
func (o *OrgListActivityFeedsParams) SetOrg(org string) {
	o.Org = org
}

// WithPage adds the page to the org list activity feeds params
func (o *OrgListActivityFeedsParams) WithPage(page *int64) *OrgListActivityFeedsParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the org list activity feeds params
func (o *OrgListActivityFeedsParams) SetPage(page *int64) {
	o.Page = page
}

// WriteToRequest writes these params to a swagger request
func (o *OrgListActivityFeedsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Date != nil {

		// query param date
		var qrDate strfmt.Date

		if o.Date != nil {
			qrDate = *o.Date
		}
		qDate := qrDate.String()
		if qDate != "" {

			if err := r.SetQueryParam("date", qDate); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
