// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewOrgListTeamMembersParams creates a new OrgListTeamMembersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrgListTeamMembersParams() *OrgListTeamMembersParams {
	return &OrgListTeamMembersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrgListTeamMembersParamsWithTimeout creates a new OrgListTeamMembersParams object
// with the ability to set a timeout on a request.
func NewOrgListTeamMembersParamsWithTimeout(timeout time.Duration) *OrgListTeamMembersParams {
	return &OrgListTeamMembersParams{
		timeout: timeout,
	}
}

// NewOrgListTeamMembersParamsWithContext creates a new OrgListTeamMembersParams object
// with the ability to set a context for a request.
func NewOrgListTeamMembersParamsWithContext(ctx context.Context) *OrgListTeamMembersParams {
	return &OrgListTeamMembersParams{
		Context: ctx,
	}
}

// NewOrgListTeamMembersParamsWithHTTPClient creates a new OrgListTeamMembersParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrgListTeamMembersParamsWithHTTPClient(client *http.Client) *OrgListTeamMembersParams {
	return &OrgListTeamMembersParams{
		HTTPClient: client,
	}
}

/*
OrgListTeamMembersParams contains all the parameters to send to the API endpoint

	for the org list team members operation.

	Typically these are written to a http.Request.
*/
type OrgListTeamMembersParams struct {

	/* ID.

	   id of the team

	   Format: int64
	*/
	ID int64

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the org list team members params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgListTeamMembersParams) WithDefaults() *OrgListTeamMembersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the org list team members params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrgListTeamMembersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the org list team members params
func (o *OrgListTeamMembersParams) WithTimeout(timeout time.Duration) *OrgListTeamMembersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the org list team members params
func (o *OrgListTeamMembersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the org list team members params
func (o *OrgListTeamMembersParams) WithContext(ctx context.Context) *OrgListTeamMembersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the org list team members params
func (o *OrgListTeamMembersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the org list team members params
func (o *OrgListTeamMembersParams) WithHTTPClient(client *http.Client) *OrgListTeamMembersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the org list team members params
func (o *OrgListTeamMembersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the org list team members params
func (o *OrgListTeamMembersParams) WithID(id int64) *OrgListTeamMembersParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the org list team members params
func (o *OrgListTeamMembersParams) SetID(id int64) {
	o.ID = id
}

// WithLimit adds the limit to the org list team members params
func (o *OrgListTeamMembersParams) WithLimit(limit *int64) *OrgListTeamMembersParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the org list team members params
func (o *OrgListTeamMembersParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithPage adds the page to the org list team members params
func (o *OrgListTeamMembersParams) WithPage(page *int64) *OrgListTeamMembersParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the org list team members params
func (o *OrgListTeamMembersParams) SetPage(page *int64) {
	o.Page = page
}

// WriteToRequest writes these params to a swagger request
func (o *OrgListTeamMembersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
