// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewOrganizationCheckUserBlockParams creates a new OrganizationCheckUserBlockParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewOrganizationCheckUserBlockParams() *OrganizationCheckUserBlockParams {
	return &OrganizationCheckUserBlockParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewOrganizationCheckUserBlockParamsWithTimeout creates a new OrganizationCheckUserBlockParams object
// with the ability to set a timeout on a request.
func NewOrganizationCheckUserBlockParamsWithTimeout(timeout time.Duration) *OrganizationCheckUserBlockParams {
	return &OrganizationCheckUserBlockParams{
		timeout: timeout,
	}
}

// NewOrganizationCheckUserBlockParamsWithContext creates a new OrganizationCheckUserBlockParams object
// with the ability to set a context for a request.
func NewOrganizationCheckUserBlockParamsWithContext(ctx context.Context) *OrganizationCheckUserBlockParams {
	return &OrganizationCheckUserBlockParams{
		Context: ctx,
	}
}

// NewOrganizationCheckUserBlockParamsWithHTTPClient creates a new OrganizationCheckUserBlockParams object
// with the ability to set a custom HTTPClient for a request.
func NewOrganizationCheckUserBlockParamsWithHTTPClient(client *http.Client) *OrganizationCheckUserBlockParams {
	return &OrganizationCheckUserBlockParams{
		HTTPClient: client,
	}
}

/*
OrganizationCheckUserBlockParams contains all the parameters to send to the API endpoint

	for the organization check user block operation.

	Typically these are written to a http.Request.
*/
type OrganizationCheckUserBlockParams struct {

	/* Org.

	   name of the organization
	*/
	Org string

	/* Username.

	   user to check
	*/
	Username string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the organization check user block params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrganizationCheckUserBlockParams) WithDefaults() *OrganizationCheckUserBlockParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the organization check user block params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *OrganizationCheckUserBlockParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the organization check user block params
func (o *OrganizationCheckUserBlockParams) WithTimeout(timeout time.Duration) *OrganizationCheckUserBlockParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the organization check user block params
func (o *OrganizationCheckUserBlockParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the organization check user block params
func (o *OrganizationCheckUserBlockParams) WithContext(ctx context.Context) *OrganizationCheckUserBlockParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the organization check user block params
func (o *OrganizationCheckUserBlockParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the organization check user block params
func (o *OrganizationCheckUserBlockParams) WithHTTPClient(client *http.Client) *OrganizationCheckUserBlockParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the organization check user block params
func (o *OrganizationCheckUserBlockParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrg adds the org to the organization check user block params
func (o *OrganizationCheckUserBlockParams) WithOrg(org string) *OrganizationCheckUserBlockParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the organization check user block params
func (o *OrganizationCheckUserBlockParams) SetOrg(org string) {
	o.Org = org
}

// WithUsername adds the username to the organization check user block params
func (o *OrganizationCheckUserBlockParams) WithUsername(username string) *OrganizationCheckUserBlockParams {
	o.SetUsername(username)
	return o
}

// SetUsername adds the username to the organization check user block params
func (o *OrganizationCheckUserBlockParams) SetUsername(username string) {
	o.Username = username
}

// WriteToRequest writes these params to a swagger request
func (o *OrganizationCheckUserBlockParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	// path param username
	if err := r.SetPathParam("username", o.Username); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
