// Code generated by go-swagger; DO NOT EDIT.

package organization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewUpdateOrgSecretParams creates a new UpdateOrgSecretParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateOrgSecretParams() *UpdateOrgSecretParams {
	return &UpdateOrgSecretParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateOrgSecretParamsWithTimeout creates a new UpdateOrgSecretParams object
// with the ability to set a timeout on a request.
func NewUpdateOrgSecretParamsWithTimeout(timeout time.Duration) *UpdateOrgSecretParams {
	return &UpdateOrgSecretParams{
		timeout: timeout,
	}
}

// NewUpdateOrgSecretParamsWithContext creates a new UpdateOrgSecretParams object
// with the ability to set a context for a request.
func NewUpdateOrgSecretParamsWithContext(ctx context.Context) *UpdateOrgSecretParams {
	return &UpdateOrgSecretParams{
		Context: ctx,
	}
}

// NewUpdateOrgSecretParamsWithHTTPClient creates a new UpdateOrgSecretParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateOrgSecretParamsWithHTTPClient(client *http.Client) *UpdateOrgSecretParams {
	return &UpdateOrgSecretParams{
		HTTPClient: client,
	}
}

/*
UpdateOrgSecretParams contains all the parameters to send to the API endpoint

	for the update org secret operation.

	Typically these are written to a http.Request.
*/
type UpdateOrgSecretParams struct {

	// Body.
	Body *models.CreateOrUpdateSecretOption

	/* Org.

	   name of organization
	*/
	Org string

	/* Secretname.

	   name of the secret
	*/
	Secretname string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update org secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateOrgSecretParams) WithDefaults() *UpdateOrgSecretParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update org secret params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateOrgSecretParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update org secret params
func (o *UpdateOrgSecretParams) WithTimeout(timeout time.Duration) *UpdateOrgSecretParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update org secret params
func (o *UpdateOrgSecretParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update org secret params
func (o *UpdateOrgSecretParams) WithContext(ctx context.Context) *UpdateOrgSecretParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update org secret params
func (o *UpdateOrgSecretParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update org secret params
func (o *UpdateOrgSecretParams) WithHTTPClient(client *http.Client) *UpdateOrgSecretParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update org secret params
func (o *UpdateOrgSecretParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update org secret params
func (o *UpdateOrgSecretParams) WithBody(body *models.CreateOrUpdateSecretOption) *UpdateOrgSecretParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update org secret params
func (o *UpdateOrgSecretParams) SetBody(body *models.CreateOrUpdateSecretOption) {
	o.Body = body
}

// WithOrg adds the org to the update org secret params
func (o *UpdateOrgSecretParams) WithOrg(org string) *UpdateOrgSecretParams {
	o.SetOrg(org)
	return o
}

// SetOrg adds the org to the update org secret params
func (o *UpdateOrgSecretParams) SetOrg(org string) {
	o.Org = org
}

// WithSecretname adds the secretname to the update org secret params
func (o *UpdateOrgSecretParams) WithSecretname(secretname string) *UpdateOrgSecretParams {
	o.SetSecretname(secretname)
	return o
}

// SetSecretname adds the secretname to the update org secret params
func (o *UpdateOrgSecretParams) SetSecretname(secretname string) {
	o.Secretname = secretname
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateOrgSecretParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param org
	if err := r.SetPathParam("org", o.Org); err != nil {
		return err
	}

	// path param secretname
	if err := r.SetPathParam("secretname", o.Secretname); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
