// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewAcceptRepoTransferParams creates a new AcceptRepoTransferParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAcceptRepoTransferParams() *AcceptRepoTransferParams {
	return &AcceptRepoTransferParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAcceptRepoTransferParamsWithTimeout creates a new AcceptRepoTransferParams object
// with the ability to set a timeout on a request.
func NewAcceptRepoTransferParamsWithTimeout(timeout time.Duration) *AcceptRepoTransferParams {
	return &AcceptRepoTransferParams{
		timeout: timeout,
	}
}

// NewAcceptRepoTransferParamsWithContext creates a new AcceptRepoTransferParams object
// with the ability to set a context for a request.
func NewAcceptRepoTransferParamsWithContext(ctx context.Context) *AcceptRepoTransferParams {
	return &AcceptRepoTransferParams{
		Context: ctx,
	}
}

// NewAcceptRepoTransferParamsWithHTTPClient creates a new AcceptRepoTransferParams object
// with the ability to set a custom HTTPClient for a request.
func NewAcceptRepoTransferParamsWithHTTPClient(client *http.Client) *AcceptRepoTransferParams {
	return &AcceptRepoTransferParams{
		HTTPClient: client,
	}
}

/*
AcceptRepoTransferParams contains all the parameters to send to the API endpoint

	for the accept repo transfer operation.

	Typically these are written to a http.Request.
*/
type AcceptRepoTransferParams struct {

	/* Owner.

	   owner of the repo to transfer
	*/
	Owner string

	/* Repo.

	   name of the repo to transfer
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the accept repo transfer params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AcceptRepoTransferParams) WithDefaults() *AcceptRepoTransferParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the accept repo transfer params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AcceptRepoTransferParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the accept repo transfer params
func (o *AcceptRepoTransferParams) WithTimeout(timeout time.Duration) *AcceptRepoTransferParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the accept repo transfer params
func (o *AcceptRepoTransferParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the accept repo transfer params
func (o *AcceptRepoTransferParams) WithContext(ctx context.Context) *AcceptRepoTransferParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the accept repo transfer params
func (o *AcceptRepoTransferParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the accept repo transfer params
func (o *AcceptRepoTransferParams) WithHTTPClient(client *http.Client) *AcceptRepoTransferParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the accept repo transfer params
func (o *AcceptRepoTransferParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the accept repo transfer params
func (o *AcceptRepoTransferParams) WithOwner(owner string) *AcceptRepoTransferParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the accept repo transfer params
func (o *AcceptRepoTransferParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the accept repo transfer params
func (o *AcceptRepoTransferParams) WithRepo(repo string) *AcceptRepoTransferParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the accept repo transfer params
func (o *AcceptRepoTransferParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *AcceptRepoTransferParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
