// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoApplyDiffPatchParams creates a new RepoApplyDiffPatchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoApplyDiffPatchParams() *RepoApplyDiffPatchParams {
	return &RepoApplyDiffPatchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoApplyDiffPatchParamsWithTimeout creates a new RepoApplyDiffPatchParams object
// with the ability to set a timeout on a request.
func NewRepoApplyDiffPatchParamsWithTimeout(timeout time.Duration) *RepoApplyDiffPatchParams {
	return &RepoApplyDiffPatchParams{
		timeout: timeout,
	}
}

// NewRepoApplyDiffPatchParamsWithContext creates a new RepoApplyDiffPatchParams object
// with the ability to set a context for a request.
func NewRepoApplyDiffPatchParamsWithContext(ctx context.Context) *RepoApplyDiffPatchParams {
	return &RepoApplyDiffPatchParams{
		Context: ctx,
	}
}

// NewRepoApplyDiffPatchParamsWithHTTPClient creates a new RepoApplyDiffPatchParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoApplyDiffPatchParamsWithHTTPClient(client *http.Client) *RepoApplyDiffPatchParams {
	return &RepoApplyDiffPatchParams{
		HTTPClient: client,
	}
}

/*
RepoApplyDiffPatchParams contains all the parameters to send to the API endpoint

	for the repo apply diff patch operation.

	Typically these are written to a http.Request.
*/
type RepoApplyDiffPatchParams struct {

	// Body.
	Body *models.UpdateFileOptions

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo apply diff patch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoApplyDiffPatchParams) WithDefaults() *RepoApplyDiffPatchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo apply diff patch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoApplyDiffPatchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) WithTimeout(timeout time.Duration) *RepoApplyDiffPatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) WithContext(ctx context.Context) *RepoApplyDiffPatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) WithHTTPClient(client *http.Client) *RepoApplyDiffPatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) WithBody(body *models.UpdateFileOptions) *RepoApplyDiffPatchParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) SetBody(body *models.UpdateFileOptions) {
	o.Body = body
}

// WithOwner adds the owner to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) WithOwner(owner string) *RepoApplyDiffPatchParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) WithRepo(repo string) *RepoApplyDiffPatchParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo apply diff patch params
func (o *RepoApplyDiffPatchParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoApplyDiffPatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
