// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoCancelScheduledAutoMergeParams creates a new RepoCancelScheduledAutoMergeParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoCancelScheduledAutoMergeParams() *RepoCancelScheduledAutoMergeParams {
	return &RepoCancelScheduledAutoMergeParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoCancelScheduledAutoMergeParamsWithTimeout creates a new RepoCancelScheduledAutoMergeParams object
// with the ability to set a timeout on a request.
func NewRepoCancelScheduledAutoMergeParamsWithTimeout(timeout time.Duration) *RepoCancelScheduledAutoMergeParams {
	return &RepoCancelScheduledAutoMergeParams{
		timeout: timeout,
	}
}

// NewRepoCancelScheduledAutoMergeParamsWithContext creates a new RepoCancelScheduledAutoMergeParams object
// with the ability to set a context for a request.
func NewRepoCancelScheduledAutoMergeParamsWithContext(ctx context.Context) *RepoCancelScheduledAutoMergeParams {
	return &RepoCancelScheduledAutoMergeParams{
		Context: ctx,
	}
}

// NewRepoCancelScheduledAutoMergeParamsWithHTTPClient creates a new RepoCancelScheduledAutoMergeParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoCancelScheduledAutoMergeParamsWithHTTPClient(client *http.Client) *RepoCancelScheduledAutoMergeParams {
	return &RepoCancelScheduledAutoMergeParams{
		HTTPClient: client,
	}
}

/*
RepoCancelScheduledAutoMergeParams contains all the parameters to send to the API endpoint

	for the repo cancel scheduled auto merge operation.

	Typically these are written to a http.Request.
*/
type RepoCancelScheduledAutoMergeParams struct {

	/* Index.

	   index of the pull request to merge

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo cancel scheduled auto merge params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCancelScheduledAutoMergeParams) WithDefaults() *RepoCancelScheduledAutoMergeParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo cancel scheduled auto merge params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCancelScheduledAutoMergeParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) WithTimeout(timeout time.Duration) *RepoCancelScheduledAutoMergeParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) WithContext(ctx context.Context) *RepoCancelScheduledAutoMergeParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) WithHTTPClient(client *http.Client) *RepoCancelScheduledAutoMergeParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) WithIndex(index int64) *RepoCancelScheduledAutoMergeParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) WithOwner(owner string) *RepoCancelScheduledAutoMergeParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) WithRepo(repo string) *RepoCancelScheduledAutoMergeParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo cancel scheduled auto merge params
func (o *RepoCancelScheduledAutoMergeParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoCancelScheduledAutoMergeParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
