// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoCreateBranchParams creates a new RepoCreateBranchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoCreateBranchParams() *RepoCreateBranchParams {
	return &RepoCreateBranchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoCreateBranchParamsWithTimeout creates a new RepoCreateBranchParams object
// with the ability to set a timeout on a request.
func NewRepoCreateBranchParamsWithTimeout(timeout time.Duration) *RepoCreateBranchParams {
	return &RepoCreateBranchParams{
		timeout: timeout,
	}
}

// NewRepoCreateBranchParamsWithContext creates a new RepoCreateBranchParams object
// with the ability to set a context for a request.
func NewRepoCreateBranchParamsWithContext(ctx context.Context) *RepoCreateBranchParams {
	return &RepoCreateBranchParams{
		Context: ctx,
	}
}

// NewRepoCreateBranchParamsWithHTTPClient creates a new RepoCreateBranchParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoCreateBranchParamsWithHTTPClient(client *http.Client) *RepoCreateBranchParams {
	return &RepoCreateBranchParams{
		HTTPClient: client,
	}
}

/*
RepoCreateBranchParams contains all the parameters to send to the API endpoint

	for the repo create branch operation.

	Typically these are written to a http.Request.
*/
type RepoCreateBranchParams struct {

	// Body.
	Body *models.CreateBranchRepoOption

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo create branch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateBranchParams) WithDefaults() *RepoCreateBranchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo create branch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateBranchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo create branch params
func (o *RepoCreateBranchParams) WithTimeout(timeout time.Duration) *RepoCreateBranchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo create branch params
func (o *RepoCreateBranchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo create branch params
func (o *RepoCreateBranchParams) WithContext(ctx context.Context) *RepoCreateBranchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo create branch params
func (o *RepoCreateBranchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo create branch params
func (o *RepoCreateBranchParams) WithHTTPClient(client *http.Client) *RepoCreateBranchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo create branch params
func (o *RepoCreateBranchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo create branch params
func (o *RepoCreateBranchParams) WithBody(body *models.CreateBranchRepoOption) *RepoCreateBranchParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo create branch params
func (o *RepoCreateBranchParams) SetBody(body *models.CreateBranchRepoOption) {
	o.Body = body
}

// WithOwner adds the owner to the repo create branch params
func (o *RepoCreateBranchParams) WithOwner(owner string) *RepoCreateBranchParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo create branch params
func (o *RepoCreateBranchParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo create branch params
func (o *RepoCreateBranchParams) WithRepo(repo string) *RepoCreateBranchParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo create branch params
func (o *RepoCreateBranchParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoCreateBranchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
