// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoCreateReleaseParams creates a new RepoCreateReleaseParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoCreateReleaseParams() *RepoCreateReleaseParams {
	return &RepoCreateReleaseParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoCreateReleaseParamsWithTimeout creates a new RepoCreateReleaseParams object
// with the ability to set a timeout on a request.
func NewRepoCreateReleaseParamsWithTimeout(timeout time.Duration) *RepoCreateReleaseParams {
	return &RepoCreateReleaseParams{
		timeout: timeout,
	}
}

// NewRepoCreateReleaseParamsWithContext creates a new RepoCreateReleaseParams object
// with the ability to set a context for a request.
func NewRepoCreateReleaseParamsWithContext(ctx context.Context) *RepoCreateReleaseParams {
	return &RepoCreateReleaseParams{
		Context: ctx,
	}
}

// NewRepoCreateReleaseParamsWithHTTPClient creates a new RepoCreateReleaseParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoCreateReleaseParamsWithHTTPClient(client *http.Client) *RepoCreateReleaseParams {
	return &RepoCreateReleaseParams{
		HTTPClient: client,
	}
}

/*
RepoCreateReleaseParams contains all the parameters to send to the API endpoint

	for the repo create release operation.

	Typically these are written to a http.Request.
*/
type RepoCreateReleaseParams struct {

	// Body.
	Body *models.CreateReleaseOption

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo create release params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateReleaseParams) WithDefaults() *RepoCreateReleaseParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo create release params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateReleaseParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo create release params
func (o *RepoCreateReleaseParams) WithTimeout(timeout time.Duration) *RepoCreateReleaseParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo create release params
func (o *RepoCreateReleaseParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo create release params
func (o *RepoCreateReleaseParams) WithContext(ctx context.Context) *RepoCreateReleaseParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo create release params
func (o *RepoCreateReleaseParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo create release params
func (o *RepoCreateReleaseParams) WithHTTPClient(client *http.Client) *RepoCreateReleaseParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo create release params
func (o *RepoCreateReleaseParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo create release params
func (o *RepoCreateReleaseParams) WithBody(body *models.CreateReleaseOption) *RepoCreateReleaseParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo create release params
func (o *RepoCreateReleaseParams) SetBody(body *models.CreateReleaseOption) {
	o.Body = body
}

// WithOwner adds the owner to the repo create release params
func (o *RepoCreateReleaseParams) WithOwner(owner string) *RepoCreateReleaseParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo create release params
func (o *RepoCreateReleaseParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo create release params
func (o *RepoCreateReleaseParams) WithRepo(repo string) *RepoCreateReleaseParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo create release params
func (o *RepoCreateReleaseParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoCreateReleaseParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
