// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoCreateStatusParams creates a new RepoCreateStatusParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoCreateStatusParams() *RepoCreateStatusParams {
	return &RepoCreateStatusParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoCreateStatusParamsWithTimeout creates a new RepoCreateStatusParams object
// with the ability to set a timeout on a request.
func NewRepoCreateStatusParamsWithTimeout(timeout time.Duration) *RepoCreateStatusParams {
	return &RepoCreateStatusParams{
		timeout: timeout,
	}
}

// NewRepoCreateStatusParamsWithContext creates a new RepoCreateStatusParams object
// with the ability to set a context for a request.
func NewRepoCreateStatusParamsWithContext(ctx context.Context) *RepoCreateStatusParams {
	return &RepoCreateStatusParams{
		Context: ctx,
	}
}

// NewRepoCreateStatusParamsWithHTTPClient creates a new RepoCreateStatusParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoCreateStatusParamsWithHTTPClient(client *http.Client) *RepoCreateStatusParams {
	return &RepoCreateStatusParams{
		HTTPClient: client,
	}
}

/*
RepoCreateStatusParams contains all the parameters to send to the API endpoint

	for the repo create status operation.

	Typically these are written to a http.Request.
*/
type RepoCreateStatusParams struct {

	// Body.
	Body *models.CreateStatusOption

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* Sha.

	   sha of the commit
	*/
	Sha string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo create status params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateStatusParams) WithDefaults() *RepoCreateStatusParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo create status params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoCreateStatusParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo create status params
func (o *RepoCreateStatusParams) WithTimeout(timeout time.Duration) *RepoCreateStatusParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo create status params
func (o *RepoCreateStatusParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo create status params
func (o *RepoCreateStatusParams) WithContext(ctx context.Context) *RepoCreateStatusParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo create status params
func (o *RepoCreateStatusParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo create status params
func (o *RepoCreateStatusParams) WithHTTPClient(client *http.Client) *RepoCreateStatusParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo create status params
func (o *RepoCreateStatusParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo create status params
func (o *RepoCreateStatusParams) WithBody(body *models.CreateStatusOption) *RepoCreateStatusParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo create status params
func (o *RepoCreateStatusParams) SetBody(body *models.CreateStatusOption) {
	o.Body = body
}

// WithOwner adds the owner to the repo create status params
func (o *RepoCreateStatusParams) WithOwner(owner string) *RepoCreateStatusParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo create status params
func (o *RepoCreateStatusParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo create status params
func (o *RepoCreateStatusParams) WithRepo(repo string) *RepoCreateStatusParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo create status params
func (o *RepoCreateStatusParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithSha adds the sha to the repo create status params
func (o *RepoCreateStatusParams) WithSha(sha string) *RepoCreateStatusParams {
	o.SetSha(sha)
	return o
}

// SetSha adds the sha to the repo create status params
func (o *RepoCreateStatusParams) SetSha(sha string) {
	o.Sha = sha
}

// WriteToRequest writes these params to a swagger request
func (o *RepoCreateStatusParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param sha
	if err := r.SetPathParam("sha", o.Sha); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
