// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeleteBranchProtectionParams creates a new RepoDeleteBranchProtectionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteBranchProtectionParams() *RepoDeleteBranchProtectionParams {
	return &RepoDeleteBranchProtectionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteBranchProtectionParamsWithTimeout creates a new RepoDeleteBranchProtectionParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteBranchProtectionParamsWithTimeout(timeout time.Duration) *RepoDeleteBranchProtectionParams {
	return &RepoDeleteBranchProtectionParams{
		timeout: timeout,
	}
}

// NewRepoDeleteBranchProtectionParamsWithContext creates a new RepoDeleteBranchProtectionParams object
// with the ability to set a context for a request.
func NewRepoDeleteBranchProtectionParamsWithContext(ctx context.Context) *RepoDeleteBranchProtectionParams {
	return &RepoDeleteBranchProtectionParams{
		Context: ctx,
	}
}

// NewRepoDeleteBranchProtectionParamsWithHTTPClient creates a new RepoDeleteBranchProtectionParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteBranchProtectionParamsWithHTTPClient(client *http.Client) *RepoDeleteBranchProtectionParams {
	return &RepoDeleteBranchProtectionParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteBranchProtectionParams contains all the parameters to send to the API endpoint

	for the repo delete branch protection operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteBranchProtectionParams struct {

	/* Name.

	   name of protected branch
	*/
	Name string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete branch protection params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteBranchProtectionParams) WithDefaults() *RepoDeleteBranchProtectionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete branch protection params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteBranchProtectionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) WithTimeout(timeout time.Duration) *RepoDeleteBranchProtectionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) WithContext(ctx context.Context) *RepoDeleteBranchProtectionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) WithHTTPClient(client *http.Client) *RepoDeleteBranchProtectionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithName adds the name to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) WithName(name string) *RepoDeleteBranchProtectionParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) SetName(name string) {
	o.Name = name
}

// WithOwner adds the owner to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) WithOwner(owner string) *RepoDeleteBranchProtectionParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) WithRepo(repo string) *RepoDeleteBranchProtectionParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete branch protection params
func (o *RepoDeleteBranchProtectionParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteBranchProtectionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
