// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeleteTagParams creates a new RepoDeleteTagParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteTagParams() *RepoDeleteTagParams {
	return &RepoDeleteTagParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteTagParamsWithTimeout creates a new RepoDeleteTagParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteTagParamsWithTimeout(timeout time.Duration) *RepoDeleteTagParams {
	return &RepoDeleteTagParams{
		timeout: timeout,
	}
}

// NewRepoDeleteTagParamsWithContext creates a new RepoDeleteTagParams object
// with the ability to set a context for a request.
func NewRepoDeleteTagParamsWithContext(ctx context.Context) *RepoDeleteTagParams {
	return &RepoDeleteTagParams{
		Context: ctx,
	}
}

// NewRepoDeleteTagParamsWithHTTPClient creates a new RepoDeleteTagParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteTagParamsWithHTTPClient(client *http.Client) *RepoDeleteTagParams {
	return &RepoDeleteTagParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteTagParams contains all the parameters to send to the API endpoint

	for the repo delete tag operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteTagParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* Tag.

	   name of tag to delete
	*/
	Tag string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete tag params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteTagParams) WithDefaults() *RepoDeleteTagParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete tag params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteTagParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete tag params
func (o *RepoDeleteTagParams) WithTimeout(timeout time.Duration) *RepoDeleteTagParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete tag params
func (o *RepoDeleteTagParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete tag params
func (o *RepoDeleteTagParams) WithContext(ctx context.Context) *RepoDeleteTagParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete tag params
func (o *RepoDeleteTagParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete tag params
func (o *RepoDeleteTagParams) WithHTTPClient(client *http.Client) *RepoDeleteTagParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete tag params
func (o *RepoDeleteTagParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo delete tag params
func (o *RepoDeleteTagParams) WithOwner(owner string) *RepoDeleteTagParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete tag params
func (o *RepoDeleteTagParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete tag params
func (o *RepoDeleteTagParams) WithRepo(repo string) *RepoDeleteTagParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete tag params
func (o *RepoDeleteTagParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithTag adds the tag to the repo delete tag params
func (o *RepoDeleteTagParams) WithTag(tag string) *RepoDeleteTagParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the repo delete tag params
func (o *RepoDeleteTagParams) SetTag(tag string) {
	o.Tag = tag
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteTagParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param tag
	if err := r.SetPathParam("tag", o.Tag); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
