// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeleteTopicParams creates a new RepoDeleteTopicParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteTopicParams() *RepoDeleteTopicParams {
	return &RepoDeleteTopicParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteTopicParamsWithTimeout creates a new RepoDeleteTopicParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteTopicParamsWithTimeout(timeout time.Duration) *RepoDeleteTopicParams {
	return &RepoDeleteTopicParams{
		timeout: timeout,
	}
}

// NewRepoDeleteTopicParamsWithContext creates a new RepoDeleteTopicParams object
// with the ability to set a context for a request.
func NewRepoDeleteTopicParamsWithContext(ctx context.Context) *RepoDeleteTopicParams {
	return &RepoDeleteTopicParams{
		Context: ctx,
	}
}

// NewRepoDeleteTopicParamsWithHTTPClient creates a new RepoDeleteTopicParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteTopicParamsWithHTTPClient(client *http.Client) *RepoDeleteTopicParams {
	return &RepoDeleteTopicParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteTopicParams contains all the parameters to send to the API endpoint

	for the repo delete topic operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteTopicParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* Topic.

	   name of the topic to delete
	*/
	Topic string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete topic params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteTopicParams) WithDefaults() *RepoDeleteTopicParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete topic params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteTopicParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete topic params
func (o *RepoDeleteTopicParams) WithTimeout(timeout time.Duration) *RepoDeleteTopicParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete topic params
func (o *RepoDeleteTopicParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete topic params
func (o *RepoDeleteTopicParams) WithContext(ctx context.Context) *RepoDeleteTopicParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete topic params
func (o *RepoDeleteTopicParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete topic params
func (o *RepoDeleteTopicParams) WithHTTPClient(client *http.Client) *RepoDeleteTopicParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete topic params
func (o *RepoDeleteTopicParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo delete topic params
func (o *RepoDeleteTopicParams) WithOwner(owner string) *RepoDeleteTopicParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete topic params
func (o *RepoDeleteTopicParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo delete topic params
func (o *RepoDeleteTopicParams) WithRepo(repo string) *RepoDeleteTopicParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete topic params
func (o *RepoDeleteTopicParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithTopic adds the topic to the repo delete topic params
func (o *RepoDeleteTopicParams) WithTopic(topic string) *RepoDeleteTopicParams {
	o.SetTopic(topic)
	return o
}

// SetTopic adds the topic to the repo delete topic params
func (o *RepoDeleteTopicParams) SetTopic(topic string) {
	o.Topic = topic
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteTopicParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param topic
	if err := r.SetPathParam("topic", o.Topic); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
