// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoDeleteWikiPageParams creates a new RepoDeleteWikiPageParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDeleteWikiPageParams() *RepoDeleteWikiPageParams {
	return &RepoDeleteWikiPageParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDeleteWikiPageParamsWithTimeout creates a new RepoDeleteWikiPageParams object
// with the ability to set a timeout on a request.
func NewRepoDeleteWikiPageParamsWithTimeout(timeout time.Duration) *RepoDeleteWikiPageParams {
	return &RepoDeleteWikiPageParams{
		timeout: timeout,
	}
}

// NewRepoDeleteWikiPageParamsWithContext creates a new RepoDeleteWikiPageParams object
// with the ability to set a context for a request.
func NewRepoDeleteWikiPageParamsWithContext(ctx context.Context) *RepoDeleteWikiPageParams {
	return &RepoDeleteWikiPageParams{
		Context: ctx,
	}
}

// NewRepoDeleteWikiPageParamsWithHTTPClient creates a new RepoDeleteWikiPageParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDeleteWikiPageParamsWithHTTPClient(client *http.Client) *RepoDeleteWikiPageParams {
	return &RepoDeleteWikiPageParams{
		HTTPClient: client,
	}
}

/*
RepoDeleteWikiPageParams contains all the parameters to send to the API endpoint

	for the repo delete wiki page operation.

	Typically these are written to a http.Request.
*/
type RepoDeleteWikiPageParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* PageName.

	   name of the page
	*/
	PageName string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo delete wiki page params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteWikiPageParams) WithDefaults() *RepoDeleteWikiPageParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo delete wiki page params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDeleteWikiPageParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) WithTimeout(timeout time.Duration) *RepoDeleteWikiPageParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) WithContext(ctx context.Context) *RepoDeleteWikiPageParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) WithHTTPClient(client *http.Client) *RepoDeleteWikiPageParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) WithOwner(owner string) *RepoDeleteWikiPageParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPageName adds the pageName to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) WithPageName(pageName string) *RepoDeleteWikiPageParams {
	o.SetPageName(pageName)
	return o
}

// SetPageName adds the pageName to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) SetPageName(pageName string) {
	o.PageName = pageName
}

// WithRepo adds the repo to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) WithRepo(repo string) *RepoDeleteWikiPageParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo delete wiki page params
func (o *RepoDeleteWikiPageParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDeleteWikiPageParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param pageName
	if err := r.SetPathParam("pageName", o.PageName); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
