// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoDownloadPullDiffOrPatchParams creates a new RepoDownloadPullDiffOrPatchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoDownloadPullDiffOrPatchParams() *RepoDownloadPullDiffOrPatchParams {
	return &RepoDownloadPullDiffOrPatchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoDownloadPullDiffOrPatchParamsWithTimeout creates a new RepoDownloadPullDiffOrPatchParams object
// with the ability to set a timeout on a request.
func NewRepoDownloadPullDiffOrPatchParamsWithTimeout(timeout time.Duration) *RepoDownloadPullDiffOrPatchParams {
	return &RepoDownloadPullDiffOrPatchParams{
		timeout: timeout,
	}
}

// NewRepoDownloadPullDiffOrPatchParamsWithContext creates a new RepoDownloadPullDiffOrPatchParams object
// with the ability to set a context for a request.
func NewRepoDownloadPullDiffOrPatchParamsWithContext(ctx context.Context) *RepoDownloadPullDiffOrPatchParams {
	return &RepoDownloadPullDiffOrPatchParams{
		Context: ctx,
	}
}

// NewRepoDownloadPullDiffOrPatchParamsWithHTTPClient creates a new RepoDownloadPullDiffOrPatchParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoDownloadPullDiffOrPatchParamsWithHTTPClient(client *http.Client) *RepoDownloadPullDiffOrPatchParams {
	return &RepoDownloadPullDiffOrPatchParams{
		HTTPClient: client,
	}
}

/*
RepoDownloadPullDiffOrPatchParams contains all the parameters to send to the API endpoint

	for the repo download pull diff or patch operation.

	Typically these are written to a http.Request.
*/
type RepoDownloadPullDiffOrPatchParams struct {

	/* Binary.

	   whether to include binary file changes. if true, the diff is applicable with `git apply`
	*/
	Binary *bool

	/* DiffType.

	   whether the output is diff or patch
	*/
	DiffType string

	/* Index.

	   index of the pull request to get

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo download pull diff or patch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDownloadPullDiffOrPatchParams) WithDefaults() *RepoDownloadPullDiffOrPatchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo download pull diff or patch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoDownloadPullDiffOrPatchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithTimeout(timeout time.Duration) *RepoDownloadPullDiffOrPatchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithContext(ctx context.Context) *RepoDownloadPullDiffOrPatchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithHTTPClient(client *http.Client) *RepoDownloadPullDiffOrPatchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBinary adds the binary to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithBinary(binary *bool) *RepoDownloadPullDiffOrPatchParams {
	o.SetBinary(binary)
	return o
}

// SetBinary adds the binary to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetBinary(binary *bool) {
	o.Binary = binary
}

// WithDiffType adds the diffType to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithDiffType(diffType string) *RepoDownloadPullDiffOrPatchParams {
	o.SetDiffType(diffType)
	return o
}

// SetDiffType adds the diffType to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetDiffType(diffType string) {
	o.DiffType = diffType
}

// WithIndex adds the index to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithIndex(index int64) *RepoDownloadPullDiffOrPatchParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithOwner(owner string) *RepoDownloadPullDiffOrPatchParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) WithRepo(repo string) *RepoDownloadPullDiffOrPatchParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo download pull diff or patch params
func (o *RepoDownloadPullDiffOrPatchParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoDownloadPullDiffOrPatchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Binary != nil {

		// query param binary
		var qrBinary bool

		if o.Binary != nil {
			qrBinary = *o.Binary
		}
		qBinary := swag.FormatBool(qrBinary)
		if qBinary != "" {

			if err := r.SetQueryParam("binary", qBinary); err != nil {
				return err
			}
		}
	}

	// path param diffType
	if err := r.SetPathParam("diffType", o.DiffType); err != nil {
		return err
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
