// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoEditBranchProtectionParams creates a new RepoEditBranchProtectionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoEditBranchProtectionParams() *RepoEditBranchProtectionParams {
	return &RepoEditBranchProtectionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoEditBranchProtectionParamsWithTimeout creates a new RepoEditBranchProtectionParams object
// with the ability to set a timeout on a request.
func NewRepoEditBranchProtectionParamsWithTimeout(timeout time.Duration) *RepoEditBranchProtectionParams {
	return &RepoEditBranchProtectionParams{
		timeout: timeout,
	}
}

// NewRepoEditBranchProtectionParamsWithContext creates a new RepoEditBranchProtectionParams object
// with the ability to set a context for a request.
func NewRepoEditBranchProtectionParamsWithContext(ctx context.Context) *RepoEditBranchProtectionParams {
	return &RepoEditBranchProtectionParams{
		Context: ctx,
	}
}

// NewRepoEditBranchProtectionParamsWithHTTPClient creates a new RepoEditBranchProtectionParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoEditBranchProtectionParamsWithHTTPClient(client *http.Client) *RepoEditBranchProtectionParams {
	return &RepoEditBranchProtectionParams{
		HTTPClient: client,
	}
}

/*
RepoEditBranchProtectionParams contains all the parameters to send to the API endpoint

	for the repo edit branch protection operation.

	Typically these are written to a http.Request.
*/
type RepoEditBranchProtectionParams struct {

	// Body.
	Body *models.EditBranchProtectionOption

	/* Name.

	   name of protected branch
	*/
	Name string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo edit branch protection params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoEditBranchProtectionParams) WithDefaults() *RepoEditBranchProtectionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo edit branch protection params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoEditBranchProtectionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) WithTimeout(timeout time.Duration) *RepoEditBranchProtectionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) WithContext(ctx context.Context) *RepoEditBranchProtectionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) WithHTTPClient(client *http.Client) *RepoEditBranchProtectionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) WithBody(body *models.EditBranchProtectionOption) *RepoEditBranchProtectionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) SetBody(body *models.EditBranchProtectionOption) {
	o.Body = body
}

// WithName adds the name to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) WithName(name string) *RepoEditBranchProtectionParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) SetName(name string) {
	o.Name = name
}

// WithOwner adds the owner to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) WithOwner(owner string) *RepoEditBranchProtectionParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) WithRepo(repo string) *RepoEditBranchProtectionParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo edit branch protection params
func (o *RepoEditBranchProtectionParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoEditBranchProtectionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
