// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoEditGitHookParams creates a new RepoEditGitHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoEditGitHookParams() *RepoEditGitHookParams {
	return &RepoEditGitHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoEditGitHookParamsWithTimeout creates a new RepoEditGitHookParams object
// with the ability to set a timeout on a request.
func NewRepoEditGitHookParamsWithTimeout(timeout time.Duration) *RepoEditGitHookParams {
	return &RepoEditGitHookParams{
		timeout: timeout,
	}
}

// NewRepoEditGitHookParamsWithContext creates a new RepoEditGitHookParams object
// with the ability to set a context for a request.
func NewRepoEditGitHookParamsWithContext(ctx context.Context) *RepoEditGitHookParams {
	return &RepoEditGitHookParams{
		Context: ctx,
	}
}

// NewRepoEditGitHookParamsWithHTTPClient creates a new RepoEditGitHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoEditGitHookParamsWithHTTPClient(client *http.Client) *RepoEditGitHookParams {
	return &RepoEditGitHookParams{
		HTTPClient: client,
	}
}

/*
RepoEditGitHookParams contains all the parameters to send to the API endpoint

	for the repo edit git hook operation.

	Typically these are written to a http.Request.
*/
type RepoEditGitHookParams struct {

	// Body.
	Body *models.EditGitHookOption

	/* ID.

	   id of the hook to get
	*/
	ID string

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo edit git hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoEditGitHookParams) WithDefaults() *RepoEditGitHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo edit git hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoEditGitHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo edit git hook params
func (o *RepoEditGitHookParams) WithTimeout(timeout time.Duration) *RepoEditGitHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo edit git hook params
func (o *RepoEditGitHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo edit git hook params
func (o *RepoEditGitHookParams) WithContext(ctx context.Context) *RepoEditGitHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo edit git hook params
func (o *RepoEditGitHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo edit git hook params
func (o *RepoEditGitHookParams) WithHTTPClient(client *http.Client) *RepoEditGitHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo edit git hook params
func (o *RepoEditGitHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo edit git hook params
func (o *RepoEditGitHookParams) WithBody(body *models.EditGitHookOption) *RepoEditGitHookParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo edit git hook params
func (o *RepoEditGitHookParams) SetBody(body *models.EditGitHookOption) {
	o.Body = body
}

// WithID adds the id to the repo edit git hook params
func (o *RepoEditGitHookParams) WithID(id string) *RepoEditGitHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo edit git hook params
func (o *RepoEditGitHookParams) SetID(id string) {
	o.ID = id
}

// WithOwner adds the owner to the repo edit git hook params
func (o *RepoEditGitHookParams) WithOwner(owner string) *RepoEditGitHookParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo edit git hook params
func (o *RepoEditGitHookParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo edit git hook params
func (o *RepoEditGitHookParams) WithRepo(repo string) *RepoEditGitHookParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo edit git hook params
func (o *RepoEditGitHookParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoEditGitHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
