// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoEditHookParams creates a new RepoEditHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoEditHookParams() *RepoEditHookParams {
	return &RepoEditHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoEditHookParamsWithTimeout creates a new RepoEditHookParams object
// with the ability to set a timeout on a request.
func NewRepoEditHookParamsWithTimeout(timeout time.Duration) *RepoEditHookParams {
	return &RepoEditHookParams{
		timeout: timeout,
	}
}

// NewRepoEditHookParamsWithContext creates a new RepoEditHookParams object
// with the ability to set a context for a request.
func NewRepoEditHookParamsWithContext(ctx context.Context) *RepoEditHookParams {
	return &RepoEditHookParams{
		Context: ctx,
	}
}

// NewRepoEditHookParamsWithHTTPClient creates a new RepoEditHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoEditHookParamsWithHTTPClient(client *http.Client) *RepoEditHookParams {
	return &RepoEditHookParams{
		HTTPClient: client,
	}
}

/*
RepoEditHookParams contains all the parameters to send to the API endpoint

	for the repo edit hook operation.

	Typically these are written to a http.Request.
*/
type RepoEditHookParams struct {

	// Body.
	Body *models.EditHookOption

	/* ID.

	   index of the hook

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo edit hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoEditHookParams) WithDefaults() *RepoEditHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo edit hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoEditHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo edit hook params
func (o *RepoEditHookParams) WithTimeout(timeout time.Duration) *RepoEditHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo edit hook params
func (o *RepoEditHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo edit hook params
func (o *RepoEditHookParams) WithContext(ctx context.Context) *RepoEditHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo edit hook params
func (o *RepoEditHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo edit hook params
func (o *RepoEditHookParams) WithHTTPClient(client *http.Client) *RepoEditHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo edit hook params
func (o *RepoEditHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo edit hook params
func (o *RepoEditHookParams) WithBody(body *models.EditHookOption) *RepoEditHookParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo edit hook params
func (o *RepoEditHookParams) SetBody(body *models.EditHookOption) {
	o.Body = body
}

// WithID adds the id to the repo edit hook params
func (o *RepoEditHookParams) WithID(id int64) *RepoEditHookParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo edit hook params
func (o *RepoEditHookParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the repo edit hook params
func (o *RepoEditHookParams) WithOwner(owner string) *RepoEditHookParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo edit hook params
func (o *RepoEditHookParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo edit hook params
func (o *RepoEditHookParams) WithRepo(repo string) *RepoEditHookParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo edit hook params
func (o *RepoEditHookParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoEditHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
