// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoGetByIDParams creates a new RepoGetByIDParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetByIDParams() *RepoGetByIDParams {
	return &RepoGetByIDParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetByIDParamsWithTimeout creates a new RepoGetByIDParams object
// with the ability to set a timeout on a request.
func NewRepoGetByIDParamsWithTimeout(timeout time.Duration) *RepoGetByIDParams {
	return &RepoGetByIDParams{
		timeout: timeout,
	}
}

// NewRepoGetByIDParamsWithContext creates a new RepoGetByIDParams object
// with the ability to set a context for a request.
func NewRepoGetByIDParamsWithContext(ctx context.Context) *RepoGetByIDParams {
	return &RepoGetByIDParams{
		Context: ctx,
	}
}

// NewRepoGetByIDParamsWithHTTPClient creates a new RepoGetByIDParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetByIDParamsWithHTTPClient(client *http.Client) *RepoGetByIDParams {
	return &RepoGetByIDParams{
		HTTPClient: client,
	}
}

/*
RepoGetByIDParams contains all the parameters to send to the API endpoint

	for the repo get by ID operation.

	Typically these are written to a http.Request.
*/
type RepoGetByIDParams struct {

	/* ID.

	   id of the repo to get

	   Format: int64
	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get by ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetByIDParams) WithDefaults() *RepoGetByIDParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get by ID params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetByIDParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get by ID params
func (o *RepoGetByIDParams) WithTimeout(timeout time.Duration) *RepoGetByIDParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get by ID params
func (o *RepoGetByIDParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get by ID params
func (o *RepoGetByIDParams) WithContext(ctx context.Context) *RepoGetByIDParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get by ID params
func (o *RepoGetByIDParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get by ID params
func (o *RepoGetByIDParams) WithHTTPClient(client *http.Client) *RepoGetByIDParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get by ID params
func (o *RepoGetByIDParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the repo get by ID params
func (o *RepoGetByIDParams) WithID(id int64) *RepoGetByIDParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo get by ID params
func (o *RepoGetByIDParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetByIDParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
