// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoGetPullRequestFilesParams creates a new RepoGetPullRequestFilesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetPullRequestFilesParams() *RepoGetPullRequestFilesParams {
	return &RepoGetPullRequestFilesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetPullRequestFilesParamsWithTimeout creates a new RepoGetPullRequestFilesParams object
// with the ability to set a timeout on a request.
func NewRepoGetPullRequestFilesParamsWithTimeout(timeout time.Duration) *RepoGetPullRequestFilesParams {
	return &RepoGetPullRequestFilesParams{
		timeout: timeout,
	}
}

// NewRepoGetPullRequestFilesParamsWithContext creates a new RepoGetPullRequestFilesParams object
// with the ability to set a context for a request.
func NewRepoGetPullRequestFilesParamsWithContext(ctx context.Context) *RepoGetPullRequestFilesParams {
	return &RepoGetPullRequestFilesParams{
		Context: ctx,
	}
}

// NewRepoGetPullRequestFilesParamsWithHTTPClient creates a new RepoGetPullRequestFilesParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetPullRequestFilesParamsWithHTTPClient(client *http.Client) *RepoGetPullRequestFilesParams {
	return &RepoGetPullRequestFilesParams{
		HTTPClient: client,
	}
}

/*
RepoGetPullRequestFilesParams contains all the parameters to send to the API endpoint

	for the repo get pull request files operation.

	Typically these are written to a http.Request.
*/
type RepoGetPullRequestFilesParams struct {

	/* Index.

	   index of the pull request to get

	   Format: int64
	*/
	Index int64

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* SkipTo.

	   skip to given file
	*/
	SkipTo *string

	/* Whitespace.

	   whitespace behavior
	*/
	Whitespace *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get pull request files params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetPullRequestFilesParams) WithDefaults() *RepoGetPullRequestFilesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get pull request files params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetPullRequestFilesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithTimeout(timeout time.Duration) *RepoGetPullRequestFilesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithContext(ctx context.Context) *RepoGetPullRequestFilesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithHTTPClient(client *http.Client) *RepoGetPullRequestFilesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndex adds the index to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithIndex(index int64) *RepoGetPullRequestFilesParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetIndex(index int64) {
	o.Index = index
}

// WithLimit adds the limit to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithLimit(limit *int64) *RepoGetPullRequestFilesParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOwner adds the owner to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithOwner(owner string) *RepoGetPullRequestFilesParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithPage(page *int64) *RepoGetPullRequestFilesParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetPage(page *int64) {
	o.Page = page
}

// WithRepo adds the repo to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithRepo(repo string) *RepoGetPullRequestFilesParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithSkipTo adds the skipTo to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithSkipTo(skipTo *string) *RepoGetPullRequestFilesParams {
	o.SetSkipTo(skipTo)
	return o
}

// SetSkipTo adds the skipTo to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetSkipTo(skipTo *string) {
	o.SkipTo = skipTo
}

// WithWhitespace adds the whitespace to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) WithWhitespace(whitespace *string) *RepoGetPullRequestFilesParams {
	o.SetWhitespace(whitespace)
	return o
}

// SetWhitespace adds the whitespace to the repo get pull request files params
func (o *RepoGetPullRequestFilesParams) SetWhitespace(whitespace *string) {
	o.Whitespace = whitespace
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetPullRequestFilesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if o.SkipTo != nil {

		// query param skip-to
		var qrSkipTo string

		if o.SkipTo != nil {
			qrSkipTo = *o.SkipTo
		}
		qSkipTo := qrSkipTo
		if qSkipTo != "" {

			if err := r.SetQueryParam("skip-to", qSkipTo); err != nil {
				return err
			}
		}
	}

	if o.Whitespace != nil {

		// query param whitespace
		var qrWhitespace string

		if o.Whitespace != nil {
			qrWhitespace = *o.Whitespace
		}
		qWhitespace := qrWhitespace
		if qWhitespace != "" {

			if err := r.SetQueryParam("whitespace", qWhitespace); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
