// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoGetReleaseAttachmentParams creates a new RepoGetReleaseAttachmentParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetReleaseAttachmentParams() *RepoGetReleaseAttachmentParams {
	return &RepoGetReleaseAttachmentParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetReleaseAttachmentParamsWithTimeout creates a new RepoGetReleaseAttachmentParams object
// with the ability to set a timeout on a request.
func NewRepoGetReleaseAttachmentParamsWithTimeout(timeout time.Duration) *RepoGetReleaseAttachmentParams {
	return &RepoGetReleaseAttachmentParams{
		timeout: timeout,
	}
}

// NewRepoGetReleaseAttachmentParamsWithContext creates a new RepoGetReleaseAttachmentParams object
// with the ability to set a context for a request.
func NewRepoGetReleaseAttachmentParamsWithContext(ctx context.Context) *RepoGetReleaseAttachmentParams {
	return &RepoGetReleaseAttachmentParams{
		Context: ctx,
	}
}

// NewRepoGetReleaseAttachmentParamsWithHTTPClient creates a new RepoGetReleaseAttachmentParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetReleaseAttachmentParamsWithHTTPClient(client *http.Client) *RepoGetReleaseAttachmentParams {
	return &RepoGetReleaseAttachmentParams{
		HTTPClient: client,
	}
}

/*
RepoGetReleaseAttachmentParams contains all the parameters to send to the API endpoint

	for the repo get release attachment operation.

	Typically these are written to a http.Request.
*/
type RepoGetReleaseAttachmentParams struct {

	/* AttachmentID.

	   id of the attachment to get

	   Format: int64
	*/
	AttachmentID int64

	/* ID.

	   id of the release

	   Format: int64
	*/
	ID int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get release attachment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetReleaseAttachmentParams) WithDefaults() *RepoGetReleaseAttachmentParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get release attachment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetReleaseAttachmentParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) WithTimeout(timeout time.Duration) *RepoGetReleaseAttachmentParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) WithContext(ctx context.Context) *RepoGetReleaseAttachmentParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) WithHTTPClient(client *http.Client) *RepoGetReleaseAttachmentParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAttachmentID adds the attachmentID to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) WithAttachmentID(attachmentID int64) *RepoGetReleaseAttachmentParams {
	o.SetAttachmentID(attachmentID)
	return o
}

// SetAttachmentID adds the attachmentId to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) SetAttachmentID(attachmentID int64) {
	o.AttachmentID = attachmentID
}

// WithID adds the id to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) WithID(id int64) *RepoGetReleaseAttachmentParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) SetID(id int64) {
	o.ID = id
}

// WithOwner adds the owner to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) WithOwner(owner string) *RepoGetReleaseAttachmentParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) WithRepo(repo string) *RepoGetReleaseAttachmentParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get release attachment params
func (o *RepoGetReleaseAttachmentParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetReleaseAttachmentParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param attachment_id
	if err := r.SetPathParam("attachment_id", swag.FormatInt64(o.AttachmentID)); err != nil {
		return err
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
