// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoGetTagParams creates a new RepoGetTagParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetTagParams() *RepoGetTagParams {
	return &RepoGetTagParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetTagParamsWithTimeout creates a new RepoGetTagParams object
// with the ability to set a timeout on a request.
func NewRepoGetTagParamsWithTimeout(timeout time.Duration) *RepoGetTagParams {
	return &RepoGetTagParams{
		timeout: timeout,
	}
}

// NewRepoGetTagParamsWithContext creates a new RepoGetTagParams object
// with the ability to set a context for a request.
func NewRepoGetTagParamsWithContext(ctx context.Context) *RepoGetTagParams {
	return &RepoGetTagParams{
		Context: ctx,
	}
}

// NewRepoGetTagParamsWithHTTPClient creates a new RepoGetTagParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetTagParamsWithHTTPClient(client *http.Client) *RepoGetTagParams {
	return &RepoGetTagParams{
		HTTPClient: client,
	}
}

/*
RepoGetTagParams contains all the parameters to send to the API endpoint

	for the repo get tag operation.

	Typically these are written to a http.Request.
*/
type RepoGetTagParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	/* Tag.

	   name of tag
	*/
	Tag string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get tag params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetTagParams) WithDefaults() *RepoGetTagParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get tag params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetTagParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get tag params
func (o *RepoGetTagParams) WithTimeout(timeout time.Duration) *RepoGetTagParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get tag params
func (o *RepoGetTagParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get tag params
func (o *RepoGetTagParams) WithContext(ctx context.Context) *RepoGetTagParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get tag params
func (o *RepoGetTagParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get tag params
func (o *RepoGetTagParams) WithHTTPClient(client *http.Client) *RepoGetTagParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get tag params
func (o *RepoGetTagParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo get tag params
func (o *RepoGetTagParams) WithOwner(owner string) *RepoGetTagParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get tag params
func (o *RepoGetTagParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo get tag params
func (o *RepoGetTagParams) WithRepo(repo string) *RepoGetTagParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get tag params
func (o *RepoGetTagParams) SetRepo(repo string) {
	o.Repo = repo
}

// WithTag adds the tag to the repo get tag params
func (o *RepoGetTagParams) WithTag(tag string) *RepoGetTagParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the repo get tag params
func (o *RepoGetTagParams) SetTag(tag string) {
	o.Tag = tag
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetTagParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	// path param tag
	if err := r.SetPathParam("tag", o.Tag); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
