// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoGetWikiPageRevisionsParams creates a new RepoGetWikiPageRevisionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoGetWikiPageRevisionsParams() *RepoGetWikiPageRevisionsParams {
	return &RepoGetWikiPageRevisionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoGetWikiPageRevisionsParamsWithTimeout creates a new RepoGetWikiPageRevisionsParams object
// with the ability to set a timeout on a request.
func NewRepoGetWikiPageRevisionsParamsWithTimeout(timeout time.Duration) *RepoGetWikiPageRevisionsParams {
	return &RepoGetWikiPageRevisionsParams{
		timeout: timeout,
	}
}

// NewRepoGetWikiPageRevisionsParamsWithContext creates a new RepoGetWikiPageRevisionsParams object
// with the ability to set a context for a request.
func NewRepoGetWikiPageRevisionsParamsWithContext(ctx context.Context) *RepoGetWikiPageRevisionsParams {
	return &RepoGetWikiPageRevisionsParams{
		Context: ctx,
	}
}

// NewRepoGetWikiPageRevisionsParamsWithHTTPClient creates a new RepoGetWikiPageRevisionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoGetWikiPageRevisionsParamsWithHTTPClient(client *http.Client) *RepoGetWikiPageRevisionsParams {
	return &RepoGetWikiPageRevisionsParams{
		HTTPClient: client,
	}
}

/*
RepoGetWikiPageRevisionsParams contains all the parameters to send to the API endpoint

	for the repo get wiki page revisions operation.

	Typically these are written to a http.Request.
*/
type RepoGetWikiPageRevisionsParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* PageName.

	   name of the page
	*/
	PageName string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo get wiki page revisions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetWikiPageRevisionsParams) WithDefaults() *RepoGetWikiPageRevisionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo get wiki page revisions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoGetWikiPageRevisionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) WithTimeout(timeout time.Duration) *RepoGetWikiPageRevisionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) WithContext(ctx context.Context) *RepoGetWikiPageRevisionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) WithHTTPClient(client *http.Client) *RepoGetWikiPageRevisionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) WithOwner(owner string) *RepoGetWikiPageRevisionsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) WithPage(page *int64) *RepoGetWikiPageRevisionsParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) SetPage(page *int64) {
	o.Page = page
}

// WithPageName adds the pageName to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) WithPageName(pageName string) *RepoGetWikiPageRevisionsParams {
	o.SetPageName(pageName)
	return o
}

// SetPageName adds the pageName to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) SetPageName(pageName string) {
	o.PageName = pageName
}

// WithRepo adds the repo to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) WithRepo(repo string) *RepoGetWikiPageRevisionsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo get wiki page revisions params
func (o *RepoGetWikiPageRevisionsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoGetWikiPageRevisionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param pageName
	if err := r.SetPathParam("pageName", o.PageName); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
