// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewRepoListActivityFeedsParams creates a new RepoListActivityFeedsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoListActivityFeedsParams() *RepoListActivityFeedsParams {
	return &RepoListActivityFeedsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoListActivityFeedsParamsWithTimeout creates a new RepoListActivityFeedsParams object
// with the ability to set a timeout on a request.
func NewRepoListActivityFeedsParamsWithTimeout(timeout time.Duration) *RepoListActivityFeedsParams {
	return &RepoListActivityFeedsParams{
		timeout: timeout,
	}
}

// NewRepoListActivityFeedsParamsWithContext creates a new RepoListActivityFeedsParams object
// with the ability to set a context for a request.
func NewRepoListActivityFeedsParamsWithContext(ctx context.Context) *RepoListActivityFeedsParams {
	return &RepoListActivityFeedsParams{
		Context: ctx,
	}
}

// NewRepoListActivityFeedsParamsWithHTTPClient creates a new RepoListActivityFeedsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoListActivityFeedsParamsWithHTTPClient(client *http.Client) *RepoListActivityFeedsParams {
	return &RepoListActivityFeedsParams{
		HTTPClient: client,
	}
}

/*
RepoListActivityFeedsParams contains all the parameters to send to the API endpoint

	for the repo list activity feeds operation.

	Typically these are written to a http.Request.
*/
type RepoListActivityFeedsParams struct {

	/* Date.

	   the date of the activities to be found

	   Format: date
	*/
	Date *strfmt.Date

	/* Limit.

	   page size of results
	*/
	Limit *int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Page.

	   page number of results to return (1-based)
	*/
	Page *int64

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo list activity feeds params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoListActivityFeedsParams) WithDefaults() *RepoListActivityFeedsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo list activity feeds params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoListActivityFeedsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithTimeout(timeout time.Duration) *RepoListActivityFeedsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithContext(ctx context.Context) *RepoListActivityFeedsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithHTTPClient(client *http.Client) *RepoListActivityFeedsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDate adds the date to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithDate(date *strfmt.Date) *RepoListActivityFeedsParams {
	o.SetDate(date)
	return o
}

// SetDate adds the date to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetDate(date *strfmt.Date) {
	o.Date = date
}

// WithLimit adds the limit to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithLimit(limit *int64) *RepoListActivityFeedsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOwner adds the owner to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithOwner(owner string) *RepoListActivityFeedsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithPage adds the page to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithPage(page *int64) *RepoListActivityFeedsParams {
	o.SetPage(page)
	return o
}

// SetPage adds the page to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetPage(page *int64) {
	o.Page = page
}

// WithRepo adds the repo to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) WithRepo(repo string) *RepoListActivityFeedsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo list activity feeds params
func (o *RepoListActivityFeedsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoListActivityFeedsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Date != nil {

		// query param date
		var qrDate strfmt.Date

		if o.Date != nil {
			qrDate = *o.Date
		}
		qDate := qrDate.String()
		if qDate != "" {

			if err := r.SetQueryParam("date", qDate); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	if o.Page != nil {

		// query param page
		var qrPage int64

		if o.Page != nil {
			qrPage = *o.Page
		}
		qPage := swag.FormatInt64(qrPage)
		if qPage != "" {

			if err := r.SetQueryParam("page", qPage); err != nil {
				return err
			}
		}
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
