// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewRepoListGitRefsParams creates a new RepoListGitRefsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoListGitRefsParams() *RepoListGitRefsParams {
	return &RepoListGitRefsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoListGitRefsParamsWithTimeout creates a new RepoListGitRefsParams object
// with the ability to set a timeout on a request.
func NewRepoListGitRefsParamsWithTimeout(timeout time.Duration) *RepoListGitRefsParams {
	return &RepoListGitRefsParams{
		timeout: timeout,
	}
}

// NewRepoListGitRefsParamsWithContext creates a new RepoListGitRefsParams object
// with the ability to set a context for a request.
func NewRepoListGitRefsParamsWithContext(ctx context.Context) *RepoListGitRefsParams {
	return &RepoListGitRefsParams{
		Context: ctx,
	}
}

// NewRepoListGitRefsParamsWithHTTPClient creates a new RepoListGitRefsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoListGitRefsParamsWithHTTPClient(client *http.Client) *RepoListGitRefsParams {
	return &RepoListGitRefsParams{
		HTTPClient: client,
	}
}

/*
RepoListGitRefsParams contains all the parameters to send to the API endpoint

	for the repo list git refs operation.

	Typically these are written to a http.Request.
*/
type RepoListGitRefsParams struct {

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Ref.

	   part or full name of the ref
	*/
	Ref string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo list git refs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoListGitRefsParams) WithDefaults() *RepoListGitRefsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo list git refs params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoListGitRefsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo list git refs params
func (o *RepoListGitRefsParams) WithTimeout(timeout time.Duration) *RepoListGitRefsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo list git refs params
func (o *RepoListGitRefsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo list git refs params
func (o *RepoListGitRefsParams) WithContext(ctx context.Context) *RepoListGitRefsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo list git refs params
func (o *RepoListGitRefsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo list git refs params
func (o *RepoListGitRefsParams) WithHTTPClient(client *http.Client) *RepoListGitRefsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo list git refs params
func (o *RepoListGitRefsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOwner adds the owner to the repo list git refs params
func (o *RepoListGitRefsParams) WithOwner(owner string) *RepoListGitRefsParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo list git refs params
func (o *RepoListGitRefsParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRef adds the ref to the repo list git refs params
func (o *RepoListGitRefsParams) WithRef(ref string) *RepoListGitRefsParams {
	o.SetRef(ref)
	return o
}

// SetRef adds the ref to the repo list git refs params
func (o *RepoListGitRefsParams) SetRef(ref string) {
	o.Ref = ref
}

// WithRepo adds the repo to the repo list git refs params
func (o *RepoListGitRefsParams) WithRepo(repo string) *RepoListGitRefsParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo list git refs params
func (o *RepoListGitRefsParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoListGitRefsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param ref
	if err := r.SetPathParam("ref", o.Ref); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
