// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// RepoSearchReader is a Reader for the RepoSearch structure.
type RepoSearchReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RepoSearchReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewRepoSearchOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 422:
		result := NewRepoSearchUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("[GET /repos/search] repoSearch", response, response.Code())
	}
}

// NewRepoSearchOK creates a RepoSearchOK with default headers values
func NewRepoSearchOK() *RepoSearchOK {
	return &RepoSearchOK{}
}

/*
RepoSearchOK describes a response with status code 200, with default header values.

SearchResults
*/
type RepoSearchOK struct {
	Payload *models.SearchResults
}

// IsSuccess returns true when this repo search o k response has a 2xx status code
func (o *RepoSearchOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this repo search o k response has a 3xx status code
func (o *RepoSearchOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo search o k response has a 4xx status code
func (o *RepoSearchOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this repo search o k response has a 5xx status code
func (o *RepoSearchOK) IsServerError() bool {
	return false
}

// IsCode returns true when this repo search o k response a status code equal to that given
func (o *RepoSearchOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the repo search o k response
func (o *RepoSearchOK) Code() int {
	return 200
}

func (o *RepoSearchOK) Error() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/search][%d] repoSearchOK %s", 200, payload)
}

func (o *RepoSearchOK) String() string {
	payload, _ := json.Marshal(o.Payload)
	return fmt.Sprintf("[GET /repos/search][%d] repoSearchOK %s", 200, payload)
}

func (o *RepoSearchOK) GetPayload() *models.SearchResults {
	return o.Payload
}

func (o *RepoSearchOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SearchResults)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRepoSearchUnprocessableEntity creates a RepoSearchUnprocessableEntity with default headers values
func NewRepoSearchUnprocessableEntity() *RepoSearchUnprocessableEntity {
	return &RepoSearchUnprocessableEntity{}
}

/*
RepoSearchUnprocessableEntity describes a response with status code 422, with default header values.

APIValidationError is error format response related to input validation
*/
type RepoSearchUnprocessableEntity struct {
	Message string
	URL     string
}

// IsSuccess returns true when this repo search unprocessable entity response has a 2xx status code
func (o *RepoSearchUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this repo search unprocessable entity response has a 3xx status code
func (o *RepoSearchUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this repo search unprocessable entity response has a 4xx status code
func (o *RepoSearchUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this repo search unprocessable entity response has a 5xx status code
func (o *RepoSearchUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this repo search unprocessable entity response a status code equal to that given
func (o *RepoSearchUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the repo search unprocessable entity response
func (o *RepoSearchUnprocessableEntity) Code() int {
	return 422
}

func (o *RepoSearchUnprocessableEntity) Error() string {
	return fmt.Sprintf("[GET /repos/search][%d] repoSearchUnprocessableEntity", 422)
}

func (o *RepoSearchUnprocessableEntity) String() string {
	return fmt.Sprintf("[GET /repos/search][%d] repoSearchUnprocessableEntity", 422)
}

func (o *RepoSearchUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header message
	hdrMessage := response.GetHeader("message")

	if hdrMessage != "" {
		o.Message = hdrMessage
	}

	// hydrates response header url
	hdrURL := response.GetHeader("url")

	if hdrURL != "" {
		o.URL = hdrURL
	}

	return nil
}
