// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoSubmitPullReviewParams creates a new RepoSubmitPullReviewParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoSubmitPullReviewParams() *RepoSubmitPullReviewParams {
	return &RepoSubmitPullReviewParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoSubmitPullReviewParamsWithTimeout creates a new RepoSubmitPullReviewParams object
// with the ability to set a timeout on a request.
func NewRepoSubmitPullReviewParamsWithTimeout(timeout time.Duration) *RepoSubmitPullReviewParams {
	return &RepoSubmitPullReviewParams{
		timeout: timeout,
	}
}

// NewRepoSubmitPullReviewParamsWithContext creates a new RepoSubmitPullReviewParams object
// with the ability to set a context for a request.
func NewRepoSubmitPullReviewParamsWithContext(ctx context.Context) *RepoSubmitPullReviewParams {
	return &RepoSubmitPullReviewParams{
		Context: ctx,
	}
}

// NewRepoSubmitPullReviewParamsWithHTTPClient creates a new RepoSubmitPullReviewParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoSubmitPullReviewParamsWithHTTPClient(client *http.Client) *RepoSubmitPullReviewParams {
	return &RepoSubmitPullReviewParams{
		HTTPClient: client,
	}
}

/*
RepoSubmitPullReviewParams contains all the parameters to send to the API endpoint

	for the repo submit pull review operation.

	Typically these are written to a http.Request.
*/
type RepoSubmitPullReviewParams struct {

	// Body.
	Body *models.SubmitPullReviewOptions

	/* ID.

	   id of the review

	   Format: int64
	*/
	ID int64

	/* Index.

	   index of the pull request

	   Format: int64
	*/
	Index int64

	/* Owner.

	   owner of the repo
	*/
	Owner string

	/* Repo.

	   name of the repo
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo submit pull review params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoSubmitPullReviewParams) WithDefaults() *RepoSubmitPullReviewParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo submit pull review params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoSubmitPullReviewParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithTimeout(timeout time.Duration) *RepoSubmitPullReviewParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithContext(ctx context.Context) *RepoSubmitPullReviewParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithHTTPClient(client *http.Client) *RepoSubmitPullReviewParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithBody(body *models.SubmitPullReviewOptions) *RepoSubmitPullReviewParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetBody(body *models.SubmitPullReviewOptions) {
	o.Body = body
}

// WithID adds the id to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithID(id int64) *RepoSubmitPullReviewParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetID(id int64) {
	o.ID = id
}

// WithIndex adds the index to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithIndex(index int64) *RepoSubmitPullReviewParams {
	o.SetIndex(index)
	return o
}

// SetIndex adds the index to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetIndex(index int64) {
	o.Index = index
}

// WithOwner adds the owner to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithOwner(owner string) *RepoSubmitPullReviewParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) WithRepo(repo string) *RepoSubmitPullReviewParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo submit pull review params
func (o *RepoSubmitPullReviewParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoSubmitPullReviewParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.Index)); err != nil {
		return err
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
