// Code generated by go-swagger; DO NOT EDIT.

package repository

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewRepoTransferParams creates a new RepoTransferParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRepoTransferParams() *RepoTransferParams {
	return &RepoTransferParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRepoTransferParamsWithTimeout creates a new RepoTransferParams object
// with the ability to set a timeout on a request.
func NewRepoTransferParamsWithTimeout(timeout time.Duration) *RepoTransferParams {
	return &RepoTransferParams{
		timeout: timeout,
	}
}

// NewRepoTransferParamsWithContext creates a new RepoTransferParams object
// with the ability to set a context for a request.
func NewRepoTransferParamsWithContext(ctx context.Context) *RepoTransferParams {
	return &RepoTransferParams{
		Context: ctx,
	}
}

// NewRepoTransferParamsWithHTTPClient creates a new RepoTransferParams object
// with the ability to set a custom HTTPClient for a request.
func NewRepoTransferParamsWithHTTPClient(client *http.Client) *RepoTransferParams {
	return &RepoTransferParams{
		HTTPClient: client,
	}
}

/*
RepoTransferParams contains all the parameters to send to the API endpoint

	for the repo transfer operation.

	Typically these are written to a http.Request.
*/
type RepoTransferParams struct {

	/* Body.

	   Transfer Options
	*/
	Body *models.TransferRepoOption

	/* Owner.

	   owner of the repo to transfer
	*/
	Owner string

	/* Repo.

	   name of the repo to transfer
	*/
	Repo string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the repo transfer params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoTransferParams) WithDefaults() *RepoTransferParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the repo transfer params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RepoTransferParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the repo transfer params
func (o *RepoTransferParams) WithTimeout(timeout time.Duration) *RepoTransferParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the repo transfer params
func (o *RepoTransferParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the repo transfer params
func (o *RepoTransferParams) WithContext(ctx context.Context) *RepoTransferParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the repo transfer params
func (o *RepoTransferParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the repo transfer params
func (o *RepoTransferParams) WithHTTPClient(client *http.Client) *RepoTransferParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the repo transfer params
func (o *RepoTransferParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the repo transfer params
func (o *RepoTransferParams) WithBody(body *models.TransferRepoOption) *RepoTransferParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the repo transfer params
func (o *RepoTransferParams) SetBody(body *models.TransferRepoOption) {
	o.Body = body
}

// WithOwner adds the owner to the repo transfer params
func (o *RepoTransferParams) WithOwner(owner string) *RepoTransferParams {
	o.SetOwner(owner)
	return o
}

// SetOwner adds the owner to the repo transfer params
func (o *RepoTransferParams) SetOwner(owner string) {
	o.Owner = owner
}

// WithRepo adds the repo to the repo transfer params
func (o *RepoTransferParams) WithRepo(repo string) *RepoTransferParams {
	o.SetRepo(repo)
	return o
}

// SetRepo adds the repo to the repo transfer params
func (o *RepoTransferParams) SetRepo(repo string) {
	o.Repo = repo
}

// WriteToRequest writes these params to a swagger request
func (o *RepoTransferParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param owner
	if err := r.SetPathParam("owner", o.Owner); err != nil {
		return err
	}

	// path param repo
	if err := r.SetPathParam("repo", o.Repo); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
