// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewUpdateUserVariableParams creates a new UpdateUserVariableParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateUserVariableParams() *UpdateUserVariableParams {
	return &UpdateUserVariableParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateUserVariableParamsWithTimeout creates a new UpdateUserVariableParams object
// with the ability to set a timeout on a request.
func NewUpdateUserVariableParamsWithTimeout(timeout time.Duration) *UpdateUserVariableParams {
	return &UpdateUserVariableParams{
		timeout: timeout,
	}
}

// NewUpdateUserVariableParamsWithContext creates a new UpdateUserVariableParams object
// with the ability to set a context for a request.
func NewUpdateUserVariableParamsWithContext(ctx context.Context) *UpdateUserVariableParams {
	return &UpdateUserVariableParams{
		Context: ctx,
	}
}

// NewUpdateUserVariableParamsWithHTTPClient creates a new UpdateUserVariableParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateUserVariableParamsWithHTTPClient(client *http.Client) *UpdateUserVariableParams {
	return &UpdateUserVariableParams{
		HTTPClient: client,
	}
}

/*
UpdateUserVariableParams contains all the parameters to send to the API endpoint

	for the update user variable operation.

	Typically these are written to a http.Request.
*/
type UpdateUserVariableParams struct {

	// Body.
	Body *models.UpdateVariableOption

	/* Variablename.

	   name of the variable
	*/
	Variablename string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update user variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateUserVariableParams) WithDefaults() *UpdateUserVariableParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update user variable params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateUserVariableParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update user variable params
func (o *UpdateUserVariableParams) WithTimeout(timeout time.Duration) *UpdateUserVariableParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update user variable params
func (o *UpdateUserVariableParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update user variable params
func (o *UpdateUserVariableParams) WithContext(ctx context.Context) *UpdateUserVariableParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update user variable params
func (o *UpdateUserVariableParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update user variable params
func (o *UpdateUserVariableParams) WithHTTPClient(client *http.Client) *UpdateUserVariableParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update user variable params
func (o *UpdateUserVariableParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update user variable params
func (o *UpdateUserVariableParams) WithBody(body *models.UpdateVariableOption) *UpdateUserVariableParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update user variable params
func (o *UpdateUserVariableParams) SetBody(body *models.UpdateVariableOption) {
	o.Body = body
}

// WithVariablename adds the variablename to the update user variable params
func (o *UpdateUserVariableParams) WithVariablename(variablename string) *UpdateUserVariableParams {
	o.SetVariablename(variablename)
	return o
}

// SetVariablename adds the variablename to the update user variable params
func (o *UpdateUserVariableParams) SetVariablename(variablename string) {
	o.Variablename = variablename
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateUserVariableParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param variablename
	if err := r.SetPathParam("variablename", o.Variablename); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
