// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"src.opensuse.org/autogits/common/gitea-generated/models"
)

// NewUserCreateHookParams creates a new UserCreateHookParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserCreateHookParams() *UserCreateHookParams {
	return &UserCreateHookParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserCreateHookParamsWithTimeout creates a new UserCreateHookParams object
// with the ability to set a timeout on a request.
func NewUserCreateHookParamsWithTimeout(timeout time.Duration) *UserCreateHookParams {
	return &UserCreateHookParams{
		timeout: timeout,
	}
}

// NewUserCreateHookParamsWithContext creates a new UserCreateHookParams object
// with the ability to set a context for a request.
func NewUserCreateHookParamsWithContext(ctx context.Context) *UserCreateHookParams {
	return &UserCreateHookParams{
		Context: ctx,
	}
}

// NewUserCreateHookParamsWithHTTPClient creates a new UserCreateHookParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserCreateHookParamsWithHTTPClient(client *http.Client) *UserCreateHookParams {
	return &UserCreateHookParams{
		HTTPClient: client,
	}
}

/*
UserCreateHookParams contains all the parameters to send to the API endpoint

	for the user create hook operation.

	Typically these are written to a http.Request.
*/
type UserCreateHookParams struct {

	// Body.
	Body *models.CreateHookOption

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user create hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCreateHookParams) WithDefaults() *UserCreateHookParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user create hook params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCreateHookParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the user create hook params
func (o *UserCreateHookParams) WithTimeout(timeout time.Duration) *UserCreateHookParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user create hook params
func (o *UserCreateHookParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user create hook params
func (o *UserCreateHookParams) WithContext(ctx context.Context) *UserCreateHookParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user create hook params
func (o *UserCreateHookParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user create hook params
func (o *UserCreateHookParams) WithHTTPClient(client *http.Client) *UserCreateHookParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user create hook params
func (o *UserCreateHookParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the user create hook params
func (o *UserCreateHookParams) WithBody(body *models.CreateHookOption) *UserCreateHookParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the user create hook params
func (o *UserCreateHookParams) SetBody(body *models.CreateHookOption) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *UserCreateHookParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
