// Code generated by go-swagger; DO NOT EDIT.

package user

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUserCurrentCheckFollowingParams creates a new UserCurrentCheckFollowingParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserCurrentCheckFollowingParams() *UserCurrentCheckFollowingParams {
	return &UserCurrentCheckFollowingParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserCurrentCheckFollowingParamsWithTimeout creates a new UserCurrentCheckFollowingParams object
// with the ability to set a timeout on a request.
func NewUserCurrentCheckFollowingParamsWithTimeout(timeout time.Duration) *UserCurrentCheckFollowingParams {
	return &UserCurrentCheckFollowingParams{
		timeout: timeout,
	}
}

// NewUserCurrentCheckFollowingParamsWithContext creates a new UserCurrentCheckFollowingParams object
// with the ability to set a context for a request.
func NewUserCurrentCheckFollowingParamsWithContext(ctx context.Context) *UserCurrentCheckFollowingParams {
	return &UserCurrentCheckFollowingParams{
		Context: ctx,
	}
}

// NewUserCurrentCheckFollowingParamsWithHTTPClient creates a new UserCurrentCheckFollowingParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserCurrentCheckFollowingParamsWithHTTPClient(client *http.Client) *UserCurrentCheckFollowingParams {
	return &UserCurrentCheckFollowingParams{
		HTTPClient: client,
	}
}

/*
UserCurrentCheckFollowingParams contains all the parameters to send to the API endpoint

	for the user current check following operation.

	Typically these are written to a http.Request.
*/
type UserCurrentCheckFollowingParams struct {

	/* Username.

	   username of followed user
	*/
	Username string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user current check following params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentCheckFollowingParams) WithDefaults() *UserCurrentCheckFollowingParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user current check following params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserCurrentCheckFollowingParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the user current check following params
func (o *UserCurrentCheckFollowingParams) WithTimeout(timeout time.Duration) *UserCurrentCheckFollowingParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user current check following params
func (o *UserCurrentCheckFollowingParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user current check following params
func (o *UserCurrentCheckFollowingParams) WithContext(ctx context.Context) *UserCurrentCheckFollowingParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user current check following params
func (o *UserCurrentCheckFollowingParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user current check following params
func (o *UserCurrentCheckFollowingParams) WithHTTPClient(client *http.Client) *UserCurrentCheckFollowingParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user current check following params
func (o *UserCurrentCheckFollowingParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUsername adds the username to the user current check following params
func (o *UserCurrentCheckFollowingParams) WithUsername(username string) *UserCurrentCheckFollowingParams {
	o.SetUsername(username)
	return o
}

// SetUsername adds the username to the user current check following params
func (o *UserCurrentCheckFollowingParams) SetUsername(username string) {
	o.Username = username
}

// WriteToRequest writes these params to a swagger request
func (o *UserCurrentCheckFollowingParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param username
	if err := r.SetPathParam("username", o.Username); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
