Workflow-PR bot
===============

Keeps ProjectGit PR in-sync with a PackageGit PR


Areas of Responsibility
-----------------------

* Detects a PackageGit PR creation against a package and creates a coresponsing PR against the ProjectGit
* When a PackageGit PR is updated, the corresponding PR against the ProjectGit is updated
* Stores reference to the PackageGit PR in the headers of the ProjectGit PR comments, for later reference
   * this allows ProjectGit PR to be merged to seperated later (via another tool, for example)
* Initiates all staging workflows via review requests


Target Usage
------------

Any project (devel, etc) that accepts PR


Config file
-----------
JSON
* _Workflows_: "pr" -- pr workflow enabled
* _Organization_: organization that holds all the packages
* _Branch_: branch updated in repo's
* _GitProjectName_: package in above org, or `org/package` for PrjGit
* _Reviewers_: accounts associated with mandatory reviews for PrjGit. Can trigger additional
               review requests for PrjGit or associated PkgGit repos. Only when all reviews are
               satisfied, will the PrjGit PR be merged.

example:

    [
     {
        "Workflows": ["pr", "direct"],
        "Organization": "autogits",
        "GitProjectName": "HiddenPrj",
        "Branch": "hidden",
        "Reviewers": []
     },
     ...
    ]


Maintainership
--------------

Maintainership information is defined per project. For reviews, package maintainers are coalesced
with project maintainers. A review by any of the maintainers is acceptable.

example:

    {
        "package1": [ "reviewer", "reviewer2"],
        "package2": [],

        // "project" maintainer
        "": ["reviewer3", "reviewer4"]
    }

